unit AddTagsUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Buttons,
  uAutoComplete;

type
  TfrmAddTags = class(TForm)
    pnBottom: TPanel;
    pnMain: TPanel;
    Label1: TLabel;
    edAddTag: TEdit;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    Label2: TLabel;
    memoTags: TMemo;
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edAddTagKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAddTags: TfrmAddTags;

implementation

uses DataUnit;

{$R *.dfm}

procedure TfrmAddTags.btnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmAddTags.btnOkClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TfrmAddTags.edAddTagKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    edAddTag.ACStrings.Add(edAddTag.Text);
  end;
end;

procedure TfrmAddTags.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmAddTags.FormCreate(Sender: TObject);
begin
  edAddTag.ACStrings.Duplicates := dupIgnore;
  edAddTag.ACOptions := [acAutoAppend, acAutoSuggest, acUseArrowKey];
  edAddTag.ACSource := acsList;
  frmData.PopulateMRUTags(edAddTag);
  edAddTag.ACEnabled := True;
end;

end.
