unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvComponentBase, JvClipboardMonitor, StdCtrls, Clipbrd, DateUtils,
  JvTrayIcon, ActnList, Menus, Buttons, IniFiles, Mask, JvExMask,
  JvToolEdit, cxGraphics, cxControls, cxLookAndFeels,
  cxLookAndFeelPainters, cxContainer, cxEdit, cxTextEdit, cxMaskEdit,
  cxDropDownEdit, JvMRUList, JvFormTransparent, ExtCtrls, JvExExtCtrls,
  JvImage, cxCalendar, Swiss, Math, JvExStdCtrls, JvEdit, JvExControls,
  JvLabel, {GR32_Objects,} GR32, ComCtrls, JvExComCtrls, JvComCtrls,
  JvNetscapeSplitter, cxImageComboBox, JvMemo, JvCombobox, JvDBTreeView,
  DB, dxmdaset, JvDBControls, JvMaskEdit, ZAbstractConnection, ZConnection,
  ZAbstractRODataset, ZAbstractDataset, ZDataset, Sessions, TeEngine, TeeProcs,
  Chart, Series, TeeData, TeeURL, TeeSeriesTextEd, JvSpin, uAutoComplete,
  Datasnap.DBClient, Vcl.ImgList, Vcl.Grids, Vcl.DBGrids, System.StrUtils,
  ShellApi;

const
    LongEnMonthNames : array[1..12] of string = ('JANUARY','FEBRUARY','MARCH',
    'APRIL','MAY','JUNE','JULY','AUGUST','SEPTEMBER','OCTOMBER','NOVEMBER','DECEMBER');
    StagesNumberSeparatar : string = '|';

type
  TPlanetRecord = record
    id, sign, subsign, zeroDegreeSign : Integer;
    lon,sLon,d, angle, zeroDegreeLon, zeroDegreeAngle, displayAngle : Double;
  end;

  TPlanetArray = array[0..20] of  TPlanetRecord;
  { retine de cate ori apare o cifra intr-un text - formatul de iesire }
  TNumberStatistic = array[1..9] of integer;

  TfrmMain = class(TForm)
    Monitor: TJvClipboardMonitor;
    mainPopupMenu: TPopupMenu;
    CmdActive1: TMenuItem;
    CmdInactive1: TMenuItem;
    CmdClose1: TMenuItem;
    Panel1: TPanel;
    btnGetDate: TButton;
    bntSaveFormat: TButton;
    btnCalculate: TButton;
    JvTrayIcon1: TJvTrayIcon;
    JvNetscapeSplitter1: TJvNetscapeSplitter;
    Panel2: TPanel;
    JvPageControl1: TJvPageControl;
    tabDate: TTabSheet;
    pnAstrology: TPanel;
    tabText: TTabSheet;
    Panel3: TPanel;
    btnCalculateText: TButton;
    chkVerified: TCheckBox;
    btnRefresh: TButton;
    edDate: TJvDateEdit;
    tabHistory: TTabSheet;
    treeHistory: TJvDBTreeView;
    memTemporar1: TdxMemData;
    dsMemTemporar: TDataSource;
    memTemporar1IdParinte: TIntegerField;
    memTemporar1Data: TDateTimeField;
    memTemporar1Comentarii: TStringField;
    memTemporar1Afisare: TStringField;
    edHistDate: TJvDBDateEdit;
    Label1: TLabel;
    Label2: TLabel;
    edHistComment: TJvDBMaskEdit;
    histPopupMenu: TPopupMenu;
    CmdHistDelete1: TMenuItem;
    SavetoDB1: TMenuItem;
    SavealltoDB1: TMenuItem;
    CmdHistDeleteAll1: TMenuItem;
    memTemporar1DateToNumber: TStringField;
    memTemporar1SunDegree: TFloatField;
    memTemporar1MooDegree: TFloatField;
    memTemporar1MerDegree: TFloatField;
    memTemporar1VenDegree: TFloatField;
    memTemporar1MarDegree: TFloatField;
    memTemporar1JupDegree: TCurrencyField;
    memTemporar1SatDegree: TFloatField;
    memTemporar1NepDegree: TFloatField;
    memTemporar1UraDegree: TFloatField;
    memTemporar1NNoDegree: TFloatField;
    memTemporar1PluDegree: TFloatField;
    memTemporar1SunNumber: TStringField;
    memTemporar1MooNumber: TStringField;
    memTemporar1MerNumber: TStringField;
    memTemporar1VenNumber: TStringField;
    memTemporar1MarNumber: TStringField;
    memTemporar1JupNumber: TStringField;
    memTemporar1SatNumber: TStringField;
    memTemporar1UraNumber: TStringField;
    memTemporar1NepNumber: TStringField;
    memTemporar1PluNumber: TStringField;
    memTemporar1NNoNumber: TStringField;
    CmdHistLoad1: TMenuItem;
    Actions: TActionList;
    Cmd_Active: TAction;
    Cmd_Inactive: TAction;
    Cmd_Close: TAction;
    Cmd_HistDelete: TAction;
    Cmd_HistSaveNode: TAction;
    Cmd_HistSaveAll: TAction;
    Cmd_HistDeleteAll: TAction;
    Cmd_HistLoad: TAction;
    JvLabel2: TLabel;
    lbSunName: TLabel;
    lbMoonName: TLabel;
    lbMercuryName: TLabel;
    lbVenusName: TLabel;
    lbMarsName: TLabel;
    lbSaturnName: TLabel;
    lbJupiterName: TLabel;
    lbUranusName: TLabel;
    lbNeptuneName: TLabel;
    lbPlutoName: TLabel;
    lbNNName: TLabel;
    lbAriesSign: TLabel;
    lbSunSign: TLabel;
    lbMoonSign: TLabel;
    lbMercurySign: TLabel;
    lbVenusSign: TLabel;
    lbMarsSign: TLabel;
    lbJupiterSign: TLabel;
    lbSaturnSign: TLabel;
    lbUranusSign: TLabel;
    lbNeptuneSign: TLabel;
    lbPlutoSign: TLabel;
    lbNordNodeSign: TLabel;
    lbAriesAngle: TLabel;
    lbSunAngle: TLabel;
    lbMoonAngle: TLabel;
    lbMercuryAngle: TLabel;
    lbVenusAngle: TLabel;
    lbMarsAngle: TLabel;
    lbJupiterAngle: TLabel;
    lbSaturnAngle: TLabel;
    lbUranusAngle: TLabel;
    lbNeptuneAngle: TLabel;
    lbPlutoAngle: TLabel;
    lbNordNodeAngle: TLabel;
    lbAriesSubSign: TLabel;
    lbSunSubSign: TLabel;
    lbMoonSubSign: TLabel;
    lbMercurySubSign: TLabel;
    lbVenusSubSign: TLabel;
    lbMarsSubSign: TLabel;
    lbJupiterSubSign: TLabel;
    lbSaturnSubSign: TLabel;
    lbUranusSubSign: TLabel;
    lbNeptuneSubSign: TLabel;
    lbPlutoSubSign: TLabel;
    lbNordNodeSubSign: TLabel;
    JvLabel15: TLabel;
    lbSun: TLabel;
    lbMoon: TLabel;
    lbMercury: TLabel;
    lbVenus: TLabel;
    lbMars: TLabel;
    lbJupiter: TLabel;
    lbSaturn: TLabel;
    lbUranus: TLabel;
    lbNeptune: TLabel;
    lbPluto: TLabel;
    lbNN: TLabel;
    JvLabel1: TLabel;
    JvLabel9: TLabel;
    JvLabel4: TLabel;
    JvLabel5: TLabel;
    JvLabel6: TLabel;
    JvLabel3: TLabel;
    JvLabel7: TLabel;
    JvLabel8: TLabel;
    edAries: TEdit;
    edSun: TEdit;
    edMoon: TEdit;
    edMercury: TEdit;
    edVenus: TEdit;
    edMars: TEdit;
    edJupiter: TEdit;
    edSaturn: TEdit;
    edUranus: TEdit;
    edNeptune: TEdit;
    edPluto: TEdit;
    edNordNode: TEdit;
    edDateNumber: TEdit;
    JvEdit1: TEdit;
    edSunNumber: TEdit;
    edMoonNumber: TEdit;
    edMercuryNumber: TEdit;
    edVenusNumber: TEdit;
    edMarsNumber: TEdit;
    edJupiterNumber: TEdit;
    edSaturnNumber: TEdit;
    edUranusNumber: TEdit;
    edNeptuneNumber: TEdit;
    edPlutoNumber: TEdit;
    edNNNumber: TEdit;
    edTotalDegreeNumber: TEdit;
    edTextNumerStages: TEdit;
    edVowels: TEdit;
    edConsonants: TEdit;
    edInitials: TEdit;
    edLasts: TEdit;
    edEvolution: TEdit;
    edInputDigits: TMemo;
    memText: TMemo;
    qryAddToDB: TZQuery;
    Label3: TLabel;
    memoDetails: TMemo;
    Label4: TLabel;
    btnSaveToDb: TButton;
    memoTags: TMemo;
    btnAddToHistory: TButton;
    edSearchFormat: TComboBox;
    chkSaveDateToHistory: TCheckBox;
    chkSaveTextToHistory: TCheckBox;
    edDictionary: TComboBox;
    edVowelsNumerStages: TEdit;
    edConsonantsNumerStages: TEdit;
    edInitialsNumerStages: TEdit;
    edLastsNumerStages: TEdit;
    Chart1: TChart;
    Series1: TBarSeries;
    edTime: TJvTimeEdit;
    edAddTag: TEdit;
    memTemporar: TClientDataSet;
    Imagini: TImageList;
    Label5: TLabel;
    edNrDecimals: TJvSpinEdit;
    tabDatabase: TTabSheet;
    Panel4: TPanel;
    Panel5: TPanel;
    qryEvents: TZQuery;
    gridEvents: TDBGrid;
    dsEvents: TDataSource;
    chkShowDataBase: TCheckBox;
    Cmd_EventLoad: TAction;
    DataBaseMenu: TPopupMenu;
    CmdEventLoad1: TMenuItem;
    qryVerifyEvent: TZQuery;
    btnLoadEvent: TBitBtn;
    Cmd_AddTagsToEvent: TAction;
    Add1: TMenuItem;
    btnAddTagsToEvent: TBitBtn;
    qryAddTags: TZQuery;
    qryDeleteEvent: TZQuery;
    Cmd_DeleteEvent: TAction;
    Deleteevent1: TMenuItem;
    btnDeleteEvent: TBitBtn;
    btnReplaceInDB: TButton;
    chkInactive: TCheckBox;
    btnCauta: TBitBtn;
    edCautaEvent: TEdit;
    chkEventsFiltered: TCheckBox;
    Label6: TLabel;
    edDateOfWeek: TEdit;
    Cmd_ShowCyclon: TAction;
    Showcyclon1: TMenuItem;
    qryReplacetoDB: TZQuery;
    procedure MonitorChange(Sender: TObject);
    procedure btnGetDateClick(Sender: TObject);
    procedure Cmd_ActiveExecute(Sender: TObject);
    procedure Cmd_InactiveExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Cmd_CloseExecute(Sender: TObject);
    procedure bntSaveFormatClick(Sender: TObject);
    procedure btnCalculateClick(Sender: TObject);
    procedure btnCalculateTextClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure memTemporar1ComentariiValidate(Sender: TField);
    procedure Cmd_HistDeleteExecute(Sender: TObject);
    procedure Cmd_HistSaveNodeExecute(Sender: TObject);
    procedure Cmd_HistSaveAllExecute(Sender: TObject);
    procedure Cmd_HistDeleteAllExecute(Sender: TObject);
    procedure Cmd_HistLoadExecute(Sender: TObject);
    procedure treeHistoryDblClick(Sender: TObject);
    procedure btnSaveToDbClick(Sender: TObject);
    procedure btnAddToHistoryClick(Sender: TObject);
    procedure edDateChange(Sender: TObject);
    procedure edAddTagKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edTimeChange(Sender: TObject);
    procedure edNrDecimalsChange(Sender: TObject);
    procedure chkShowDataBaseClick(Sender: TObject);
    procedure Cmd_EventLoadExecute(Sender: TObject);
    procedure Cmd_AddTagsToEventExecute(Sender: TObject);
    procedure btnLoadEventClick(Sender: TObject);
    procedure btnAddTagsToEventClick(Sender: TObject);
    procedure Cmd_DeleteEventExecute(Sender: TObject);
    procedure btnDeleteEventClick(Sender: TObject);
    procedure btnReplaceInDBClick(Sender: TObject);
    procedure chkInactiveClick(Sender: TObject);
    procedure btnCautaClick(Sender: TObject);
    procedure chkEventsFilteredClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure edCautaEventChange(Sender: TObject);
    procedure gridEventsDblClick(Sender: TObject);
    procedure Cmd_ShowCyclonExecute(Sender: TObject);
  private
    { Private declarations }
    IdEvents : Integer; // retine id-ul eventul-ui selectat pt update ulterior
    function IsDate(str: string): Boolean;
    function Calculate(y1,m1,d1:Word; t1 : Double) : TPlanetArray;
    function getTextNumbersStatistics(aText: string): TNumberStatistic;

    procedure AddToMemo(aString : String);
    procedure EventHide (var aMessage : TMessage); message WM_USER+1;
    procedure LoadFromINI;
    procedure SaveToINI(OnlySettings : Boolean = False);
    procedure WriteToEdit(planets : array of TPlanetRecord; planetsNumber : Integer);
    procedure WriteToTmpDataSet(aDate : TDateTime; aParentId : Integer=1);
    procedure WriteToDB(planets : array of TPlanetRecord; planetsNumber : Integer);
    procedure ReplaceToDB(planets : array of TPlanetRecord; planetsNumber : Integer);
    procedure WriteToChart(aStatistics: TNumberStatistic);
    procedure ClearTextEdits;
    procedure ClearDateEdits;

    procedure AddTmpDateTreeNode(aDate: TDateTime; aTip: integer); overload;
    procedure AddTmpTextTreeNode(aText: string); overload;

    procedure PopulateMRUTags;
    function VerifyExistTagInMemo (aTag : string) : Boolean;

    function existsInTree(aDate: TDateTime): boolean; overload;
    function existsInTree(aString: string): boolean; overload;

    procedure InternalFieldGetText(Sender: TField; var Text: string;DisplayText: Boolean);

    function existsEvent : string;
    procedure OpenEventsDataSet;

    function FormatStageNumbers (aLon : Double): string;
    function GetLastStageNumber (aNumber : string) : Integer;

    function GetCyclonParam(aType : Integer; aParamType : string): string;
  public
    { Public declarations }
  end;


function DateTimeStrEval(const DateTimeFormat : string; const DateTimeStr : string) : TDateTime;
function ExeVersion: String;
function CountTimes(SubString, Txt: string): integer;

var
  frmMain: TfrmMain;
  Signs : Array[1..12] of Char = ('x','c','v','b','n','m','X','C','V','B','N','M');  
  SignsNames : Array[1..12] of String = ('Aries','Taurus','Gemini','Cancer','Leo','Virgo','Libra','Scorpio','Sagittarius','Capricorn','Aquarius','Pisces');
  PlantesNames : Array[0..12] of String = ('Sun',           'Moon',         'Mercury',      'Venus',        'Mars',         'Jupiter',      'Saturn',       'Uranus',       'Neptune',      'Pluto',    'Earth', 'Moon Nord Node Mean',  'Moon Nord Node True');
  PlantesColors : Array[0..10] of TColor = (
  {TColor($0AEFD2), TColor($000000), TColor($808040), TColor($C1C466), TColor($0000FF), TColor($0080FF),TColor($000080),TColor($FF0000),TColor($FF0080),TColor($FF8080),TColor($000080)}
  TColor($000000FF), TColor($00646464),TColor($00005B1E), TColor($009EB800), TColor($000000FF), TColor($007400D4), TColor($00000000), TColor($00FF0000),TColor($00847500),TColor($0074009F),TColor($00000075));
  SignsColors : Array[0..11] of TColor = (
    TColor($0ABB2FF),TColor($009CCEFF),TColor($0090E7FF),TColor($0099FFFD),
    TColor($0099FFFD),TColor($00E1FFCC),TColor($00FFEDC6),TColor($00FFD2C3),
    TColor($00FFC6D3),TColor($00FFBAF3),TColor($00EBC3FF),TColor($00D6CCFF)
  );
  ChartBarsColors : Array[1..9] of TColor = (TColor($3C14DC),TColor($87B8DE),TColor($D4FF7F),TColor($DDA0DD),TColor($4763FF),TColor($3F85CD),TColor($FFFF00),TColor($D30094),TColor($0045FF));
  natalPlanets,transitPlanets : TPlanetArray;
  checkedPlanets : Integer;
  ExeVerStr        : String;
  IsInserting : Boolean; // daca este in desfasurare operatiunea de insert; sa nu mai faca validare pe campuri 
  tmpSession: THSession; // sesiunea curenta
  rootNode: TTreeNode;  // primul nod - radacina din tree-ul de history

implementation

uses DataUnit, FunctiiUtile, FunctiiAstro, FunctiiNumerologie, AddTagsUnit;

{$R *.dfm}

function CountTimes(SubString, Txt: string): integer;
var HowMuch : integer;
begin
 HowMuch := 0;
 while ContainsText(Txt, SubString) = True do
  begin
    Txt := SysUtils.StringReplace(Txt, SubString, '', [rfIgnoreCase]);
    HowMuch := HowMuch + 1;
  end;
 Result := HowMuch;
end;


function ExeVersion: String;
var ExePChar  : PChar;
    aHandle   : DWord;
    aSize     : Integer;
    lpData    : Pointer;
    lpBuffer  : Pointer;
    lpSize    : DWord;
    LangStr   : String;
    LangId    : DWord;
begin
  if ExeVerStr = '' then begin
     ExePChar := PChar(ParamStr(0));
     aSize := GetFileVersionInfoSize(ExePChar, aHandle);
     if aSize = 0 then Exit;//RaiseLastWin32Error;
     lpData := AllocMem(aSize);
     try
       if not GetFileVersionInfo(ExePChar, 0, aSize, lpData) then
          Exit;//Abort;
       if not VerQueryValue(lpData, '\VarFileInfo\Translation', lpBuffer, lpSize) then
          Exit;//Abort;
       LangId  := PDWord(lpBuffer)^;
       LangStr := Format('%.4x%.4x',[LangId and $0FFFF,LangId shr 16]);
       if not VerQueryValue(lpData, PChar('\StringFileInfo\'+LangStr+'\FileVersion'), lpBuffer, lpSize) then
          Exit;//Abort;
       ExeVerStr := StrPas(PChar(lpBuffer));
     finally
       FreeMem(lpData, aSize);
     end;
  end;
  Result := ExeVerStr;
end;

procedure TfrmMain.InternalFieldGetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
begin
  Text := Copy(Sender.AsString, 1, 50);
end;

function TfrmMain.IsDate(str: string): Boolean;
var
  dt: TDateTime;
begin
  Result := True;
  try
    dt := StrToDate(str);
  except
    Result := False;
  end;
end;

procedure TfrmMain.MonitorChange(Sender: TObject);
var aText : String;
    DateFound : Boolean;
    i : Integer;
    aDate : TDateTime;

begin
  chkVerified.Checked := False;
  if Monitor.Enabled then begin
    JvTrayIcon1.ShowApplication;
    with Clipboard do
    begin
      btnReplaceInDB.Enabled := False;
      if FormatCount = 0 then
        memText.Lines.Add('The Clipboard is empty')
      else
      if HasFormat(CF_TEXT) then begin
        aText := AsText;
        // daca iese la verificare simpla de data - formatul local de data
        if IsDate(aText) then begin
          memText.Clear;
          memText.Lines.Add(aText);
          aDate := StrToDate(aText);
          edDate.Date := aDate;
          chkVerified.Checked := True;
          ClearDateEdits;
          btnSaveToDb.Enabled := True;
          btnCalculateClick(Sender);
          //WriteToDB(natalPlanets,checkedPlanets);
          JvPageControl1.ActivePageIndex := 0;
          ClearTextEdits;
        end
        else begin
          // daca nu incerc cu diferite formate luate din ini
          DateFound := False;
          i := 0;
          while (i < edSearchFormat.Items.Count) and (not DateFound) do
          begin
            aDate := DateTimeStrEval(edSearchFormat.Items[i],aText);
            if Double(aDate) <> 0.0 then
              DateFound := True;
            i := i+1;
          end;
          { daca am gasit data }
          if DateFound then begin
            memText.Clear;
            memText.Lines.Add(DateToStr(aDate));
            edDate.Date := aDate;
            chkVerified.Checked := True;
            ClearDateEdits;
            btnSaveToDb.Enabled := True;
            btnCalculateClick(Sender);
            //WriteToDB(natalPlanets,checkedPlanets);
            JvPageControl1.ActivePageIndex := 0;
            ClearTextEdits;
            WriteToTmpDataSet(aDate);
          end
          else
          begin
            // daca nu gasesc ca fiind data - completez datele de text
            memText.Clear;
            memText.Lines.Add(aText);
            ClearDateEdits;
            ClearDateEdits;
            btnCalculateTextClick(Sender);
            JvPageControl1.ActivePageIndex := 1;
            edDate.Date := 0;
            btnSaveToDb.Enabled := False;
          end;
        end;
      end;
    end;
    self.BringToFront;
  end;
end;

procedure TfrmMain.OpenEventsDataSet;
begin
  if qryEvents.Active then
    qryEvents.Active := False;

  qryEvents.Active := True;
  qryEvents.FieldByName('Details').OnGetText := InternalFieldGetText;
  qryEvents.FieldByName('Tags').OnGetText := InternalFieldGetText;
end;

procedure TfrmMain.PopulateMRUTags;
var
  aTags, aTag : string;
begin
  // populez tag-urile din baza de date pt autocomplete
  edAddTag.ACStrings.Clear;
  frmdata.qryTags.Active := False;
  frmdata.qryTags.Active := True;
  frmdata.qryTags.First;
  while not frmdata.qryTags.Eof do
  begin
    aTags := frmdata.qryTags.FieldByName('tags').AsString;
    repeat
      aTag := Copy(aTags,0,Pos(',',aTags)-1);
      aTags := Copy(aTags,Pos(',',aTags)+1,Length(aTags)-Pos(',',aTags));
      if aTag <> '' then
        edAddTag.ACStrings.Add(aTag);
    until Pos(',',aTags) = 0;

    if Pos(',',aTags) = 0 then
        aTag := aTags;
    edAddTag.ACStrings.Add(aTag);
    frmdata.qryTags.Next;
  end;
end;

procedure TfrmMain.ReplaceToDB(planets: array of TPlanetRecord;
  planetsNumber: Integer);
var i : Integer;
    y1,m1,d1,h1, m2:Word;
    jd1, t1: Double;
    planetsLon : array[0..20] of Double;
    planetsSign : array[0..20] of Integer;
    planetsElemental : array[0..20] of Integer;
    planetsType : array[0..20] of Integer;
begin
  // actualizez datele in baza de date

  // iau datele si le setez in parametrii
  y1 := YearOf(edDate.Date);
  m1 := MonthOf(edDate.Date);
  d1 := DayOf(edDate.Date);
  h1 := HourOf(edTime.Time);
  m2 := MinuteOf(edTime.Time);
  t1 := 0;
  jd1 := swe_julday(y1,m1,d1,t1,1);

  // pun id-ul
  qryReplacetoDB.ParamByName('IdEvents').AsInteger := IdEvents;

  qryReplacetoDB.ParamByName('year').AsInteger := y1;
  qryReplacetoDB.ParamByName('month').AsInteger := m1;
  qryReplacetoDB.ParamByName('day').AsInteger := d1;
  qryReplacetoDB.ParamByName('hour').AsInteger := h1;
  qryReplacetoDB.ParamByName('minute').AsInteger := m2;
  qryReplacetoDB.ParamByName('jd').AsFloat := jd1;

  // setez parametrii pt detalii si tags
  qryReplacetoDB.ParamByName('details').AsString := memoDetails.Text;
  qryReplacetoDB.ParamByName('tags').AsString := memoTags.Text;

  // iau datele pt fiecare planeta intr-un array
  for i := 0 to planetsNumber do begin
    planetsLon[i] := planets[i].lon;
    planetsSign[i] := planets[i].sign;
    planetsElemental[i] := elementOfSign(planets[i].sign);
    planetsType[i] :=  typeOfSign(planets[i].sign);
  end;

  // setez parametrii pt longitute
  qryReplacetoDB.ParamByName('lonsu').AsFloat := planetsLon[0];
  qryReplacetoDB.ParamByName('lonmo').AsFloat := planetsLon[1];
  qryReplacetoDB.ParamByName('lonme').AsFloat := planetsLon[2];
  qryReplacetoDB.ParamByName('lonve').AsFloat := planetsLon[3];
  qryReplacetoDB.ParamByName('lonma').AsFloat := planetsLon[4];
  qryReplacetoDB.ParamByName('lonju').AsFloat := planetsLon[5];
  qryReplacetoDB.ParamByName('lonsa').AsFloat := planetsLon[6];
  qryReplacetoDB.ParamByName('lonur').AsFloat := planetsLon[7];
  qryReplacetoDB.ParamByName('lonne').AsFloat := planetsLon[8];
  qryReplacetoDB.ParamByName('lonpl').AsFloat := planetsLon[9];
  qryReplacetoDB.ParamByName('lonnn').AsFloat := planetsLon[11];

  // setez parametrii pt sign
  qryReplacetoDB.ParamByName('ssu').AsFloat := planetsSign[0];
  qryReplacetoDB.ParamByName('smo').AsFloat := planetsSign[1];
  qryReplacetoDB.ParamByName('sme').AsFloat := planetsSign[2];
  qryReplacetoDB.ParamByName('sve').AsFloat := planetsSign[3];
  qryReplacetoDB.ParamByName('sma').AsFloat := planetsSign[4];
  qryReplacetoDB.ParamByName('sju').AsFloat := planetsSign[5];
  qryReplacetoDB.ParamByName('ssa').AsFloat := planetsSign[6];
  qryReplacetoDB.ParamByName('sur').AsFloat := planetsSign[7];
  qryReplacetoDB.ParamByName('sne').AsFloat := planetsSign[8];
  qryReplacetoDB.ParamByName('spl').AsFloat := planetsSign[9];
  qryReplacetoDB.ParamByName('snn').AsFloat := planetsSign[11];

  // setez parametrii pt elemental
  qryReplacetoDB.ParamByName('esu').AsFloat := planetsElemental[0];
  qryReplacetoDB.ParamByName('emo').AsFloat := planetsElemental[1];
  qryReplacetoDB.ParamByName('eme').AsFloat := planetsElemental[2];
  qryReplacetoDB.ParamByName('eve').AsFloat := planetsElemental[3];
  qryReplacetoDB.ParamByName('ema').AsFloat := planetsElemental[4];
  qryReplacetoDB.ParamByName('eju').AsFloat := planetsElemental[5];
  qryReplacetoDB.ParamByName('esa').AsFloat := planetsElemental[6];
  qryReplacetoDB.ParamByName('eur').AsFloat := planetsElemental[7];
  qryReplacetoDB.ParamByName('ene').AsFloat := planetsElemental[8];
  qryReplacetoDB.ParamByName('epl').AsFloat := planetsElemental[9];
  qryReplacetoDB.ParamByName('enn').AsFloat := planetsElemental[11];

  // setez parametrii pt type
  qryReplacetoDB.ParamByName('msu').AsFloat := planetsType[0];
  qryReplacetoDB.ParamByName('mmo').AsFloat := planetsType[1];
  qryReplacetoDB.ParamByName('mme').AsFloat := planetsType[2];
  qryReplacetoDB.ParamByName('mve').AsFloat := planetsType[3];
  qryReplacetoDB.ParamByName('mma').AsFloat := planetsType[4];
  qryReplacetoDB.ParamByName('mju').AsFloat := planetsType[5];
  qryReplacetoDB.ParamByName('msa').AsFloat := planetsType[6];
  qryReplacetoDB.ParamByName('mur').AsFloat := planetsType[7];
  qryReplacetoDB.ParamByName('mne').AsFloat := planetsType[8];
  qryReplacetoDB.ParamByName('mpl').AsFloat := planetsType[9];
  qryReplacetoDB.ParamByName('mnn').AsFloat := planetsType[11];

  // fac update-ul
  qryReplacetoDB.ExecSQL;
end;

function DateTimeStrEval(const DateTimeFormat : string;
                         const DateTimeStr : string) : TDateTime;
var i,ii,iii,j : integer;
    Retvar : TDateTime;
    Tmp,
    Fmt,Data,Mask,Spec : string;
    Year,Month,Day,Hour,
    Minute,Second,MSec : word;
    AmPm : integer;
begin
  Year := 1;
  Month := 1;
  Day := 1;
  Hour := 0;
  Minute := 0;
  Second := 0;
  MSec := 0;
  Fmt := UpperCase(DateTimeFormat);
  Data := UpperCase(DateTimeStr);
  i := 1;
  Mask := '';
  AmPm := 0;

  while i < length(Fmt) do begin
    if (Fmt[i] in ['A','P','D','M','Y','H','N','S','Z']) and (length(Data) > 0)  then begin
      // Start of a date specifier
      Mask  := Fmt[i];
      ii := i + 1;

      // Keep going till not valid specifier
      while true do begin
        if ii > length(Fmt) then Break; // End of specifier string
        Spec := Mask + Fmt[ii];

        if (Spec = 'DD') or (Spec = 'DDD') or (Spec = 'DDDD') or
           (Spec = 'MM') or (Spec = 'MMM') or (Spec = 'MMMM') or
           (Spec = 'YY') or (Spec = 'YYY') or (Spec = 'YYYY') or
           (Spec = 'HH') or (Spec = 'NN') or (Spec = 'SS') or
           (Spec = 'ZZ') or (Spec = 'ZZZ') or
           (Spec = 'AP') or (Spec = 'AM') or (Spec = 'AMP') 
        then begin
          Mask := Spec;
          inc(ii);
        end
        else begin
          // End of or Invalid specifier
          Break;
        end;
      end;

      // Got a valid specifier ? - evaluate it from data string
      if (Mask <> '') and (length(Data) > 0) then begin
        // Day 1..31
        if (Mask = 'DD') then begin
          // elimin si caracterele nedorite gen: ,/\ etc; 
           Day := StrToIntDef(validChars(trim(copy(Data,1,2))),0);

           if (Day < 10) and (copy(Data,1,1)<>'0') then
             delete(Data,1,1)
           else
            delete(Data,1,2);
        end;

        // Day Sun..Sat (Just remove from data string)
        if Mask = 'DDD' then delete(Data,1,3);

        // Day Sunday..Saturday (Just remove from data string LEN)
        if Mask = 'DDDD' then begin
          Tmp := copy(Data,1,3);
          for iii := 1 to 7 do begin
            if Tmp = Uppercase(copy(LongDayNames[iii],1,3)) then begin
              delete(Data,1,length(LongDayNames[iii]));
              Break;
            end;
          end;
        end;

        // Month 1..12
        if (Mask = 'MM') then begin
           Month := StrToIntDef(trim(copy(Data,1,2)),0);
           delete(Data,1,2);
        end;

        // Month Jan..Dec
        if Mask = 'MMM' then begin
          Tmp := copy(Data,1,3);
          for iii := 1 to 12 do begin
            if Tmp = Uppercase(copy(LongMonthNames[iii],1,3)) then begin
              Month := iii;
              delete(Data,1,3);
              Break;
            end;
          end;
        end;

        // Month January..December
        if Mask = 'MMMM' then begin
          j := Pos(' ',Data)-1;
          if j > 0 then
          begin
            Tmp := copy(Data,1,j);
            for iii := 1 to 12 do begin
              if (Tmp = Uppercase(copy(LongMonthNames[iii],1,j))) then
              begin
                Month := iii;
                delete(Data,1,length(LongMonthNames[iii]));
                Break;
              end
              else
              if (Tmp = Uppercase(copy(LongEnMonthNames[iii],1,j))) then begin
                Month := iii;
                delete(Data,1,length(LongEnMonthNames[iii]));
                Break;
              end;
            end;
          end;
        end;

        // Year 2 Digit
        if Mask = 'YY' then begin
          Year := StrToIntDef(copy(Data,1,2),0);
          delete(Data,1,2);
          if Year < TwoDigitYearCenturyWindow then
            Year := (YearOf(Date) div 100) * 100 + Year
          else
            Year := (YearOf(Date) div 100 - 1) * 100 + Year;
        end;

        // Year 4 Digit
        if Mask = 'YYYY' then begin
          Year := StrToIntDef(copy(Trim(Data),1,4),0);
          delete(Data,1,4);
        end;

        // Hours
        if Mask = 'HH' then begin
           Hour := StrToIntDef(trim(copy(Data,1,2)),0);
           delete(Data,1,2);
        end;

        // Minutes
        if Mask = 'NN' then begin
           Minute := StrToIntDef(trim(copy(Data,1,2)),0);
           delete(Data,1,2);
        end;

        // Seconds
        if Mask = 'SS' then begin
           Second := StrToIntDef(trim(copy(Data,1,2)),0);
           delete(Data,1,2);
        end;

        // Milliseconds
        if (Mask = 'ZZ') or (Mask = 'ZZZ') then begin
           MSec := StrToIntDef(trim(copy(Data,1,3)),0);
           delete(Data,1,3);
        end;


        // AmPm A or P flag
        if (Mask = 'AP') then begin
           if Data[1] = 'A' then
             AmPm := -1
           else
             AmPm := 1;
           delete(Data,1,1);
        end;

        // AmPm AM or PM flag
        if (Mask = 'AM') or (Mask = 'AMP') or (Mask = 'AMPM') then begin
           if copy(Data,1,2) = 'AM' then
             AmPm := -1
           else
             AmPm := 1;
           delete(Data,1,2);
        end;

        Mask := '';
        i := ii;
      end;
    end
    else begin
      // Remove delimiter from data string
      if length(Data) > 1 then delete(Data,1,1);
      inc(i);
    end;
  end;

  if AmPm = 1 then Hour := Hour + 12;
  if not TryEncodeDateTime(Year,Month,Day,Hour,Minute,Second,MSec,Retvar) then
    Retvar := 0.0;
  Result := Retvar;
end;


procedure TfrmMain.btnGetDateClick(Sender: TObject);
var aDate : TDateTime;
begin
 // iau ce e in memo si calculez 
  aDate := DateTimeStrEval(edSearchFormat.Text,memText.Text);
  if aDate <> 0.0 then  begin
    edDate.Date := aDate;
    chkVerified.Checked := True;
    btnCalculateClick(Sender);    
  end;
end;

procedure TfrmMain.btnLoadEventClick(Sender: TObject);
begin
  Cmd_EventLoadExecute(Sender);
end;

procedure TfrmMain.AddTmpDateTreeNode(aDate: TDateTime; aTip: integer);
var
  aNode: TTreeNode;
  aHistNode: THSessionNodes;
begin
  if aTip < 0 then
  begin
    tmpSession.SessionDate := aDate;
    tmpSession.SessionText := 'Session: ' + DateToStr(aDate);
    rootNode := treeHistory.Items.AddChildObjectFirst(
      nil, 'Session: ' + DateToStr(aDate), Pointer(tmpSession));
    //rootNode := treeHistory.Items.AddFirst(nil,'Session: '+DateToStr(aDate));
  end
  else
  begin
    if chkSaveDateToHistory.Checked then
      if not existsInTree(aDate) then
      begin
        aHistNode := THSessionNodes.Create;
        aHistNode.NodeDate := aDate;
        aHistNode.NodeText := '';
        aHistNode.NodeComment := '';
        aNode := treeHistory.Items.AddChildObject(rootNode, DateToStr(
          aDate), Pointer(aHistNode));
      end;
  end;
end;

procedure TfrmMain.AddTmpTextTreeNode(aText: string);
var
  i: integer;
  displayText: string;
  aNode: TTreeNode;
  aHistNode: THSessionNodes;
begin
  if chkSaveTextToHistory.Checked then
    if not existsInTree(aText) then
    begin
      aHistNode := THSessionNodes.Create;
      aHistNode.NodeDate := 0.0;
      aHistNode.NodeComment := '';
      aHistNode.NodeText := aText;
      // iau numai cateva caractere din text pt afisare in tree
      displayText := '';
      for i := 1 to Min(15,Length(aText)) do
        displayText := displayText + aText[i];
      aNode := treeHistory.Items.AddChildObject(rootNode, displayText, Pointer(aHistNode));
    end;
end;

procedure TfrmMain.AddToMemo(aString: String);
var aDate : TDateTime;
begin
  memText.Clear;
  aDate := DateTimeStrEval(edSearchFormat.Text,aString);
  if aDate <> 0.0 then  begin
    edDate.Date := aDate;
    chkVerified.Checked := True;
    btnCalculateClick(nil);    
  end;
  memText.Lines.Add(DateToStr(aDate));
end;

procedure TfrmMain.btnAddTagsToEventClick(Sender: TObject);
begin
  Cmd_AddTagsToEventExecute(Sender);
end;

procedure TfrmMain.Cmd_ActiveExecute(Sender: TObject);
begin
  Monitor.Enabled := True;
  CmdActive1.ImageIndex := 0;
  CmdInactive1.ImageIndex := -1;
end;

procedure TfrmMain.Cmd_AddTagsToEventExecute(Sender: TObject);
var
  lFrm : TfrmAddTags;
  newTags : string;
begin
  // adaug tag-uri la un event existent
  if qryEvents.Active then
  begin
    lFrm := TfrmAddTags.Create(self);
    lFrm.memoTags.Text :=  qryEvents.FieldByName('Tags').AsString;
    lFrm.ShowModal;
    if lFrm.ModalResult = mrOk then
    begin
      qryAddTags.Active := False;
      newTags := qryEvents.FieldByName('Tags').AsString;
      newTags := newTags + ','+trim(lFrm.edAddTag.Text);
      qryAddTags.ParamByName('Tags').AsString := newTags;
      qryAddTags.ParamByName('IdEvents').AsInteger := qryEvents.FieldByName('IdEvents').AsInteger;
      qryAddTags.ExecSQL;
      OpenEventsDataSet;
    end;
  end
  else
  begin
    ShowMessage('The events query needs to be open!');
  end;
end;

procedure TfrmMain.Cmd_InactiveExecute(Sender: TObject);
begin
  Monitor.Enabled := False;
  CmdActive1.ImageIndex := -1;
  CmdInactive1.ImageIndex := 0;
end;

function TfrmMain.GetCyclonParam(aType : Integer; aParamType : string): string;
var
  lYear, lMonth, lDay, lMinute, lHour : string;
begin
  // e pentru data curent
  if aType = -1  then
  begin
    lYear := IntToStr(YearOf(Now));
    lMonth := IntToStr(MonthOf(Now));
    if Length(lMonth)=1 then
      lMonth := '0'+lMonth;
    lDay := IntToStr(DayOf(Now));
    if Length(lDay)=1 then
      lDay := '0'+lDay;
    lHour := IntToStr(HourOf(Now));
    if Length(lHour)=1 then
      lHour := '0'+lHour;
    lMinute := IntToStr(MinuteOf(Now));
    if Length(lMinute)=1 then
      lMinute := '0'+lMinute;
  end
  else
  // iau din grid
  begin
    qryEvents.DisableControls;
    if gridEvents.SelectedRows.IndexOf(gridEvents.SelectedRows.Items[aType]) > -1 then begin
      qryEvents.Bookmark :=  gridEvents.SelectedRows.Items[aType];
      lYear := qryEvents.FieldByName('Year').AsString;
      lMonth := qryEvents.FieldByName('Month').AsString;
      if Length(lMonth)=1 then
        lMonth := '0'+lMonth;
      lDay := qryEvents.FieldByName('Day').AsString;
      if Length(lDay)=1 then
        lDay := '0'+lDay;
      lHour := qryEvents.FieldByName('Hour').AsString;
      if Length(lHour)=1 then
        lHour := '0'+lHour;
      lMinute := qryEvents.FieldByName('Minute').AsString;
      if Length(lMinute)=1 then
        lMinute := '0'+lMinute;
    end;
    qryEvents.EnableControls;
  end;

  Result := '/'+aParamType+' "'+lYear+'-'+lMonth+'-'+lDay+' '+lHour+':'+lMinute+'"';
end;

procedure TfrmMain.Cmd_ShowCyclonExecute(Sender: TObject);
var
  I, lCount : Integer;
  lNatalText, lTransitText : string;
  lYear, lMonth, lDay, lMinute, lHour : string;
  lFileName, lParameters : string;
begin
  //
  if gridEvents.SelectedRows.Count >0  then
    if gridEvents.SelectedRows.Count > 2  then
      lCount := 2
    else
      lCount := gridEvents.SelectedRows.Count;

  case lCount  of
    1 : begin
      // adaug parametrul pt natal
      lNatalText :=  GetCyclonParam(0,'natal');
      // adaug parametrul pt transit - iau data de azi
      lTransitText :=  GetCyclonParam(-1,'transit');
    end;
    2 : begin
      // adaug parametrul pt natal
      lNatalText :=  GetCyclonParam(0,'natal');
      // adaug parametrul pt transit
       lTransitText :=  GetCyclonParam(1,'transit');
    end;
  end;

  lFileName := 'cyclon.exe';
  lParameters := lNatalText+' '+lTransitText;
  ShellExecute(handle,'open',PChar(lFileName), PChar(lParameters),'',SW_SHOWNORMAL);
end;

procedure TfrmMain.edAddTagKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    edAddTag.ACStrings.Add(edAddTag.Text);
    if not VerifyExistTagInMemo(edAddTag.Text) then
      if memoTags.Text <> '' then
        memoTags.Text := memoTags.Text + ','+edAddTag.Text
      else
        memoTags.Text := edAddTag.Text;
  end;
end;

procedure TfrmMain.edCautaEventChange(Sender: TObject);
begin
  if edCautaEvent.Text <> '' then
    btnCautaClick(Sender)
  else
    qryEvents.Active := False;
end;

procedure TfrmMain.edDateChange(Sender: TObject);
begin
  btnCalculateClick(Sender);
end;

procedure TfrmMain.edNrDecimalsChange(Sender: TObject);
begin
  btnCalculateClick(Sender);
end;

procedure TfrmMain.edTimeChange(Sender: TObject);
begin
  btnCalculateClick(Sender);
end;

procedure TfrmMain.EventHide(var aMessage: TMessage);
begin
  JvTrayIcon1.HideApplication;
end;

function TfrmMain.existsInTree(aDate: TDateTime): boolean;
var
  i: integer;
begin
  // daca o valoare exista in tree
  Result := False;
  for i := 1 to treeHistory.Items.Count - 1 do
    if THSessionNodes(treeHistory.Items[i].Data).NodeDate = aDate then
    begin
      Result := True;
      Exit;
    end;
end;

function TfrmMain.existsEvent : string;
var
  y1,m1,d1,h1, m2:Word;
begin
  // verific daca exista deja evenimentul
  Result := '';
  y1 := YearOf(edDate.Date);
  m1 := MonthOf(edDate.Date);
  d1 := DayOf(edDate.Date);
  h1 := HourOf(edTime.Time);
  m2 := MinuteOf(edTime.Time);

  qryVerifyEvent.ParamByName('Year').AsInteger := y1;
  qryVerifyEvent.ParamByName('Month').AsInteger := m1;
  qryVerifyEvent.ParamByName('Day').AsInteger := d1;
  qryVerifyEvent.ParamByName('Hour').AsInteger := h1;
  qryVerifyEvent.ParamByName('Minute').AsInteger := m2;

  qryVerifyEvent.Active := True;
  if not qryVerifyEvent.IsEmpty then
  begin
    Result := 'Details: ' + qryVerifyEvent.FieldByName('Details').AsString +
              '; Tags: '+ qryVerifyEvent.FieldByName('Tags').AsString;
  end;
  qryVerifyEvent.Active := False;
end;

function TfrmMain.existsInTree(aString: string): boolean;
var
  i: integer;
begin
  // daca un string exista in tree
  Result := False;
  for i := 1 to treeHistory.Items.Count - 1 do
    if THSessionNodes(treeHistory.Items[i].Data).NodeText = aString then
    begin
      Result := True;
      Exit;
    end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin

  AddFontResource('STRFNSAN.TTF') ;
  PostMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0) ;

  Caption := Caption + ' v. '+ExeVersion;
  edDictionary.ItemIndex := 0;

  LoadFromINI;
  JvTrayIcon1.Active := True;
  PostMessage(Handle,WM_USER+1,0,0);
  memTemporar.CreateDataSet;
  memTemporar.FieldByName('Comentarii').OnValidate := memTemporar1ComentariiValidate;
  memTemporar.FieldByName('Data').OnValidate := memTemporar1ComentariiValidate;
  memTemporar.Active := True;
  IsInserting := False;
  WriteToTmpDataSet(Now,-1);

  edAddTag.ACStrings.Duplicates := dupIgnore;
  edAddTag.ACOptions := [acAutoAppend, acAutoSuggest, acUseArrowKey];
  edAddTag.ACSource := acsList;
  //PopulateMRUTags;
  frmData.PopulateMRUTags(edAddTag);
  edAddTag.ACEnabled := True;

  edDate.Date := Now;
  //edTime.Time := 0.5;
  edTime.Time := Now;

  IdEvents := -1;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  RemoveFontResource('STRFNSAN.TTF') ;
  SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0)
end;

function TfrmMain.GetLastStageNumber(aNumber: string): Integer;
var lString : string;
begin
  Result := 0;
  if CountTimes(StagesNumberSeparatar,aNumber) > 1 then
  begin
     aNumber := ReverseString(aNumber);
     lString := copy(aNumber,0,pos(StagesNumberSeparatar,aNumber)-1);
     lString := ReverseString(lString);
     Result := StrToInt(lString);
  end
  else
  if CountTimes(StagesNumberSeparatar,aNumber) = 1 then
  begin
     lString := copy(aNumber,pos(StagesNumberSeparatar,aNumber)+1,Length(aNumber)-1);
     Result := StrToInt(lString);
  end;

end;

function TfrmMain.getTextNumbersStatistics(aText: string): TNumberStatistic;
var
  i, j: integer;
begin
  // numara nr de aparitii ale fiecarei cifre in textul primit
  for i := 1 to 9 do
  begin
    Result[i] := 0;
    for j := 1 to Length(aText) do
      if aText[j] = IntToStr(i) then
        Result[i] := Result[i] + 1;
  end;
end;

procedure TfrmMain.gridEventsDblClick(Sender: TObject);
begin
  Cmd_EventLoadExecute(Sender);
end;

function TfrmMain.FormatStageNumbers(aLon : Double): string;
var lStages : TStagesReduce;
    lTmpNumber, i : Integer;
begin
  lStages := reduceNr(Floor(aLon),True);
  Result := '';
  lTmpNumber := 0;
  for i := 2 to 10 do begin
    if lStages[i] <> -1 then begin
      lTmpNumber := lStages[i];
      if i = 1 then
        Result := IntToStr(lStages[i])
      else
        Result := Result + StagesNumberSeparatar + IntToStr(lStages[i]);
    end;
  end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caNone;
  PostMessage(Handle,WM_USER+1,0,0);
end;

procedure TfrmMain.Cmd_CloseExecute(Sender: TObject);
begin
  SaveToINI(True);
  Application.Terminate;
end;

procedure TfrmMain.Cmd_DeleteEventExecute(Sender: TObject);
begin
  // sterg eventul selectat
  if qryEvents.Active then
  begin
    if MessageDlg('Are you sure you want to delele selected event?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
    begin
      qryDeleteEvent.ParamByName('IdEvents').AsInteger:= qryEvents.FieldByName('IdEvents').AsInteger;
      qryDeleteEvent.ExecSQL;
      OpenEventsDataSet;
    end;
  end;
end;

procedure TfrmMain.Cmd_EventLoadExecute(Sender: TObject);
var lDate : TDatetime;
    lYear, lMonth, lDay, lHour, lMinute : Integer;
begin
  // loads un event din database
  if qryEvents.Active  then
  begin
    IdEvents := qryEvents.FieldByName('IdEvents').AsInteger;
    lYear := qryEvents.FieldByName('Year').AsInteger;
    lMonth := qryEvents.FieldByName('Month').AsInteger;
    lDay := qryEvents.FieldByName('Day').AsInteger;
    lHour := qryEvents.FieldByName('Hour').AsInteger;
    lMinute := qryEvents.FieldByName('Minute').AsInteger;

    lDate := EncodeDateTime(lYear,lMonth,lDay,lHour,lMinute,0,0);

    edDate.Date := lDate;
    chkVerified.Checked := True;
    btnCalculateClick(Sender);
    JvPageControl1.ActivePageIndex := 0;
    ClearTextEdits;

    memoDetails.Text := qryEvents.FieldByName('Details').AsString;
    memoTags.Text := qryEvents.FieldByName('Tags').AsString;
    btnReplaceInDB.Enabled := True;
  end
  else
    ShowMessage('The events query needs to be open!');
end;

procedure TfrmMain.LoadFromINI;
var aFile : TIniFile;
    lDir : string;
    i, aCount : Integer;
begin
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  aFile :=  TIniFile.Create(lDir+'ClipboardToDate.ini');
  aCount := aFile.ReadInteger('DateFormats','FormatCount',0);
  for i := 1 to aCount do begin
    edSearchFormat.Items.Add(aFile.ReadString('DateFormats','Format'+IntToStr(i),'dd/mm/yyyy'));
  end;
  edNrDecimals.Value := aFile.ReadInteger('Settings','AngleDecimalsNumber',1);
  aFile.Free;
end;

procedure TfrmMain.bntSaveFormatClick(Sender: TObject);
begin
 // salvez formatul specificat in ini
  SaveToINI;
end;

procedure TfrmMain.SaveToINI (OnlySettings : Boolean = False);
var aFile : TIniFile;
    lDir : string;
    i, aCount : Integer;
    AlreadyExists : Boolean;
begin
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  aFile :=  TIniFile.Create(lDir+'ClipboardToDate.ini');
  aCount := edSearchFormat.Items.Count;
  if not  OnlySettings then
  begin
    AlreadyExists := False;
    for i := 0 to aCount-1 do
      if edSearchFormat.Items[i] = edSearchFormat.Text then
           AlreadyExists := True;
    if not AlreadyExists then
      aCount := aCount + 1;
    aFile.WriteInteger('DateFormats','FormatCount',aCount);
    if not AlreadyExists then begin
      for i := 0 to aCount-2 do
        aFile.WriteString('DateFormats','Format'+IntToStr(i+1),edSearchFormat.Items[i]);
      aFile.WriteString('DateFormats','Format'+IntToStr(aCount),edSearchFormat.Text);
    end
    else
      for i := 0 to aCount-1 do
        aFile.WriteString('DateFormats','Format'+IntToStr(i+1),edSearchFormat.Items[i]);
  end
  else
  begin
    aFile.WriteInteger('Settings','AngleDecimalsNumber',Floor(edNrDecimals.Value));
  end;
  aFile.Free;
end;

procedure TfrmMain.btnAddToHistoryClick(Sender: TObject);
var
  aText: string;
  aDate: TDateTime;
  dateFound: boolean;
  i: integer;
begin
  aText := memText.Text;
  dateFound := False;
  i := 0;
  while (i < edSearchFormat.Items.Count) and (not DateFound) do
  begin
    aDate := DateTimeStrEval(edSearchFormat.Items[i], aText);
    if aDate <> 0.0 then
      DateFound := True;
    i := i + 1;
  end;
  if dateFound then
    AddTmpDateTreeNode(aDate, 1)
  else
    AddTmpTextTreeNode(aText);
end;

procedure TfrmMain.btnCalculateClick(Sender: TObject);
var y1,m1,d1:Word;
    t1 : Double;
    aStages,lStages : TStagesReduce;
    aText : string;
    i : Integer;
begin
  // aici vreau sa calculez datele astrologice
  y1 := YearOf(edDate.Date);
  m1 := MonthOf(edDate.Date);
  d1 := DayOf(edDate.Date);
  //t1 := HourOf(edTime.Time)+MinuteOf(edTime.Time)*60;
  //t1 := 0;
  t1 := TimeOf(edTime.Time)*24;
  natalPlanets := Calculate(y1,m1,d1,t1);
  WriteToEdit(natalPlanets,checkedPlanets);
  lStages := reduceDate(edDate.Date,True);
  //aStages := reduceNr(reduceDate(edDate.Date,True)[1]+reduceDate(edDate.Date,True)[2]+reduceDate(edDate.Date,True)[1],True);
  aStages := reduceNr(lStages[1]+lStages[2]+lStages[3],True);
  aText := IntToStr(reduceDate(edDate.Date,True)[1])+'.'+
  IntToStr(reduceDate(edDate.Date,True)[2])+'.'+IntToStr(reduceDate(edDate.Date,True)[3]);
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      aText := aText +'='+ IntToStr(aStages[i]);
  end;
  edDateNumber.Text := aText;
  JvPageControl1.ActivePageIndex := 0;
  ClearTextEdits;
  btnSaveToDb.Enabled := True;
  // afisez ziua saptamanii
  if DayOfTheWeek(edDate.Date) = 7 then
    edDateOfWeek.Text := FormatSettings.LongDayNames[1]
  else
    edDateOfWeek.Text := FormatSettings.LongDayNames[DayOfTheWeek(edDate.Date)+1];
end;

function TfrmMain.Calculate(y1, m1, d1: Word; t1: Double): TPlanetArray;
var i:Integer;
    jd1: Double;
begin
  jd1 := swe_julday(y1,m1,d1,t1,1);

  checkedPlanets := 0;
  for  i:= 0 to High(PlantesNames)  do begin
    with result[checkedPlanets] do
    begin
        id := i;
        swe_calc_ut(jd1,i,iflag,xx[0],sErr);
        lon := roundTo(xx[0],-2);
        d := xx[2];
        sLon := xx[3];
        if round(lon/30) <> lon/30 then
          sign := floor(lon/30) + 1
        else
          sign := round(lon / 30);
        angle := roundTo(lon  - (sign-1) * 30,-2);
        if sign = 0 then sign := 1;
        if round(angle/2.5) <> angle/2.5 then
          subsign := floor(angle/2.5)+1
        else
          subsign := round(angle/2.5);
        if subsign = 0 then subsign := 1;
        zeroDegreeLon := lon;
        zeroDegreeSign := sign;
        zeroDegreeAngle := angle;
    end;
    Inc(checkedPlanets);
  end;
end;

procedure TfrmMain.chkEventsFilteredClick(Sender: TObject);
begin
  if not chkEventsFiltered.Checked then
  begin
    chkEventsFiltered.Checked := False;
    qryEvents.Active := False;
    qryEvents.SQL[1] := '';
    OpenEventsDataSet;
    chkEventsFiltered.Enabled := False;
  end;
end;

procedure TfrmMain.chkInactiveClick(Sender: TObject);
begin
  if chkInactive.Checked then
    Cmd_InactiveExecute(Sender)
  else
    Cmd_ActiveExecute(Sender);
end;

procedure TfrmMain.chkShowDataBaseClick(Sender: TObject);
begin
  if not chkShowDataBase.Checked then
    qryEvents.Active := False
  else
  begin
    OpenEventsDataSet;
  end;
end;

procedure TfrmMain.WriteToChart(aStatistics: TNumberStatistic);
var
  i : Integer;
begin
  // afisez pe chart
  // sterg bar-urile deja existente

  Series1.Clear;

  // adaug bar-urile
  for I := 0 to 9 do
  begin
    Series1.AddBar(aStatistics[i],IntToStr(i),ChartBarsColors[i+1]);
  end;

end;

procedure TfrmMain.WriteToDB(planets: array of TPlanetRecord;
  planetsNumber: Integer);
var i : Integer;
    y1,m1,d1,h1, m2:Word;
    jd1, t1: Double;
    planetsLon : array[0..20] of Double;
    planetsSign : array[0..20] of Integer;
    planetsElemental : array[0..20] of Integer;
    planetsType : array[0..20] of Integer;
begin
  // scriu datele in baza de date

  // iau datele si le setez in parametrii
  y1 := YearOf(edDate.Date);
  m1 := MonthOf(edDate.Date);
  d1 := DayOf(edDate.Date);
  h1 := HourOf(edTime.Time);
  m2 := MinuteOf(edTime.Time);
  t1 := 0;
  jd1 := swe_julday(y1,m1,d1,t1,1);
  qryAddToDB.ParamByName('year').AsInteger := y1;
  qryAddToDB.ParamByName('month').AsInteger := m1;
  qryAddToDB.ParamByName('day').AsInteger := d1;
  qryAddToDB.ParamByName('hour').AsInteger := h1;
  qryAddToDB.ParamByName('minute').AsInteger := m2;
  qryAddToDB.ParamByName('jd').AsFloat := jd1;

  // setez parametrii pt detalii si tags
  qryAddToDB.ParamByName('details').AsString := memoDetails.Text;
  qryAddToDB.ParamByName('tags').AsString := memoTags.Text;

  // iau datele pt fiecare planeta intr-un array
  for i := 0 to planetsNumber do begin
    planetsLon[i] := planets[i].lon;
    planetsSign[i] := planets[i].sign;
    planetsElemental[i] := elementOfSign(planets[i].sign);
    planetsType[i] :=  typeOfSign(planets[i].sign);
  end;

  // setez parametrii pt longitute
  qryAddToDB.ParamByName('lonsu').AsFloat := planetsLon[0];
  qryAddToDB.ParamByName('lonmo').AsFloat := planetsLon[1];
  qryAddToDB.ParamByName('lonme').AsFloat := planetsLon[2];
  qryAddToDB.ParamByName('lonve').AsFloat := planetsLon[3];
  qryAddToDB.ParamByName('lonma').AsFloat := planetsLon[4];
  qryAddToDB.ParamByName('lonju').AsFloat := planetsLon[5];
  qryAddToDB.ParamByName('lonsa').AsFloat := planetsLon[6];
  qryAddToDB.ParamByName('lonur').AsFloat := planetsLon[7];
  qryAddToDB.ParamByName('lonne').AsFloat := planetsLon[8];
  qryAddToDB.ParamByName('lonpl').AsFloat := planetsLon[9];
  qryAddToDB.ParamByName('lonnn').AsFloat := planetsLon[11];

  // setez parametrii pt sign
  qryAddToDB.ParamByName('ssu').AsFloat := planetsSign[0];
  qryAddToDB.ParamByName('smo').AsFloat := planetsSign[1];
  qryAddToDB.ParamByName('sme').AsFloat := planetsSign[2];
  qryAddToDB.ParamByName('sve').AsFloat := planetsSign[3];
  qryAddToDB.ParamByName('sma').AsFloat := planetsSign[4];
  qryAddToDB.ParamByName('sju').AsFloat := planetsSign[5];
  qryAddToDB.ParamByName('ssa').AsFloat := planetsSign[6];
  qryAddToDB.ParamByName('sur').AsFloat := planetsSign[7];
  qryAddToDB.ParamByName('sne').AsFloat := planetsSign[8];
  qryAddToDB.ParamByName('spl').AsFloat := planetsSign[9];
  qryAddToDB.ParamByName('snn').AsFloat := planetsSign[11];

  // setez parametrii pt elemental
  qryAddToDB.ParamByName('esu').AsFloat := planetsElemental[0];
  qryAddToDB.ParamByName('emo').AsFloat := planetsElemental[1];
  qryAddToDB.ParamByName('eme').AsFloat := planetsElemental[2];
  qryAddToDB.ParamByName('eve').AsFloat := planetsElemental[3];
  qryAddToDB.ParamByName('ema').AsFloat := planetsElemental[4];
  qryAddToDB.ParamByName('eju').AsFloat := planetsElemental[5];
  qryAddToDB.ParamByName('esa').AsFloat := planetsElemental[6];
  qryAddToDB.ParamByName('eur').AsFloat := planetsElemental[7];
  qryAddToDB.ParamByName('ene').AsFloat := planetsElemental[8];
  qryAddToDB.ParamByName('epl').AsFloat := planetsElemental[9];
  qryAddToDB.ParamByName('enn').AsFloat := planetsElemental[11];

  // setez parametrii pt type
  qryAddToDB.ParamByName('msu').AsFloat := planetsType[0];
  qryAddToDB.ParamByName('mmo').AsFloat := planetsType[1];
  qryAddToDB.ParamByName('mme').AsFloat := planetsType[2];
  qryAddToDB.ParamByName('mve').AsFloat := planetsType[3];
  qryAddToDB.ParamByName('mma').AsFloat := planetsType[4];
  qryAddToDB.ParamByName('mju').AsFloat := planetsType[5];
  qryAddToDB.ParamByName('msa').AsFloat := planetsType[6];
  qryAddToDB.ParamByName('mur').AsFloat := planetsType[7];
  qryAddToDB.ParamByName('mne').AsFloat := planetsType[8];
  qryAddToDB.ParamByName('mpl').AsFloat := planetsType[9];
  qryAddToDB.ParamByName('mnn').AsFloat := planetsType[11];

  // fac insert-ul
  qryAddToDB.ExecSQL;
end;

procedure TfrmMain.WriteToEdit(planets: array of TPlanetRecord;
  planetsNumber: Integer);
var i,j,k,l,aTmpNumber:Integer;
    t1 : Double;
    aStages : TStagesReduce;
    aText, lDegreeFormat, aZeros : string;
    lastValues : array[0..12] of Integer; // iau ultimele valori pt fiecare degree
begin
  aZeros := '';
  for I := 1 to Floor(edNrDecimals.Value) do
    aZeros := aZeros + '0';
  lDegreeFormat := ',0.'+aZeros+';,-0.'+aZeros;

  for i := 0 to 12 do
    lastValues[i] := 0;
  for i := 0 to planetsNumber do begin
    tempDouble := planets[i].lon;
    j := planets[i].sign;
    t1 := planets[i].angle;
    k := planets[i].subsign;
    case i of
      0 :
      begin
        lbSunName.Font.Color := PlantesColors[i];
        lbSun.Font.Color := PlantesColors[i];
        edSun.Text := FormatFloat(lDegreeFormat,tempDouble);
        //edSun.Text := FloatToStr(tempDouble);
        lbSunSign.Caption := Signs[j];
        //lbSunSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbSunSign.Font.Color := SignsColors[planets[i].sign];
        lbSunSign.Color := SignsColors[planets[i].sign];
        //lbSunAngle.Caption := FloatToStr(t1);
        lbSunAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbSunSubSign.Caption := Signs[k];
        //lbSunSubSign.Font.Color :=WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbSunSubSign.Font.Color := SignsColors[planets[i].subsign];
        lbSunSubSign.Color := SignsColors[planets[i].subsign];
        edSunNumber.Text := FormatStageNumbers(tempDouble);
        lastValues[i] := GetLastStageNumber(edSunNumber.Text);
        //lastValues[i] := aTmpNumber;
      end;
      1 :
      begin
        lbMoonName.Font.Color := PlantesColors[i];
        lbMoon.Font.Color := PlantesColors[i];
        edMoon.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbMoonSign.Caption := Signs[j];
        //lbMoonSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbMoonSign.Font.Color := SignsColors[planets[i].sign];
        lbMoonSign.Color := SignsColors[planets[i].sign];
        //lbMoonAngle.Caption := FloatToStr(t1);
        lbMoonAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbMoonSubSign.Caption := Signs[k];
        //lbMoonSubSign.Font.Color :=WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbMoonSubSign.Font.Color := SignsColors[planets[i].Subsign];
        lbMoonSubSign.Color := SignsColors[planets[i].Subsign];
        edMoonNumber.Text := FormatStageNumbers(tempDouble);
        lastValues[i] := GetLastStageNumber(edMoonNumber.Text);
        //lastValues[i] := aTmpNumber;
      end;
      2 :
      begin
        lbMercuryName.Font.Color := PlantesColors[i];
        lbMercury.Font.Color := PlantesColors[i];
        edMercury.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbMercurySign.Caption := Signs[j];
        //lbMercurySign.Font.Color : =WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbMercurySign.Font.Color := SignsColors[planets[i].sign];
        lbMercurySign.Color := SignsColors[planets[i].sign];
        //lbMercuryAngle.Caption := FloatToStr(t1);
        lbMercuryAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbMercurySubSign.Caption := Signs[k];
        //lbMercurySubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbMercurySubSign.Font.Color := SignsColors[planets[i].Subsign];
        lbMercurySubSign.Color := SignsColors[planets[i].Subsign];
        edMercuryNumber.Text := FormatStageNumbers(tempDouble);
        //lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edMercuryNumber.Text);
      end;
      3 :
      begin
        lbVenusName.Font.Color := PlantesColors[i];
        lbVenus.Font.Color := PlantesColors[i];
        //edVenus.Text := FloatToStr(tempDouble);
        edVenus.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbVenusSign.Caption := Signs[j];
        //lbVenusSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbVenusSign.Font.Color := SignsColors[planets[i].sign];
        lbVenusSign.Color := SignsColors[planets[i].sign];
        //lbVenusAngle.Caption := FloatToStr(t1);
        lbVenusAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbVenusSubSign.Caption := Signs[k];
        //lbVenusSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbVenusSubSign.Font.Color := SignsColors[planets[i].Subsign];
        lbVenusSubSign.Color := SignsColors[planets[i].Subsign];
        edVenusNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edVenusNumber.Text);
      end;
      4 :
      begin
        lbMarsName.Font.Color := PlantesColors[i];
        lbMars.Font.Color := PlantesColors[i];
        edMars.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbMarsSign.Caption := Signs[j];
        //lbMarsSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbMarsSign.Font.Color := SignsColors[planets[i].sign];
        lbMarsSign.Color := SignsColors[planets[i].sign];
        //lbMarsAngle.Caption := FloatToStr(t1);
        lbMarsAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbMarsSubSign.Caption := Signs[k];
        //lbMarsSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbMarsSubSign.Font.Color := SignsColors[planets[i].Subsign];
        lbMarsSubSign.Color := SignsColors[planets[i].Subsign];
        edMarsNumber.Text := FormatStageNumbers(tempDouble);
        //lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edMarsNumber.Text);
      end;
      5 :
      begin
        lbJupiterName.Font.Color := PlantesColors[i];
        lbJupiter.Font.Color := PlantesColors[i];
        edJupiter.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbJupiterSign.Caption := Signs[j];
        //lbJupiterSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbJupiterSign.Font.Color := SignsColors[planets[i].sign];
        lbJupiterSign.Color := SignsColors[planets[i].sign];
        //lbJupiterAngle.Caption := FloatToStr(t1);
        lbJupiterAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbJupiterSubSign.Caption := Signs[k];
        //lbJupiterSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbJupiterSubSign.Font.Color := SignsColors[planets[i].subsign];
        lbJupiterSubSign.Color := SignsColors[planets[i].subsign];
        edJupiterNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edJupiterNumber.Text);
      end;
      6 :
      begin
        lbSaturnName.Font.Color := PlantesColors[i];
        lbSaturn.Font.Color := PlantesColors[i];
        edSaturn.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbSaturnSign.Caption := Signs[j];
        //lbSaturnSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbSaturnSign.Font.Color := SignsColors[planets[i].sign];
        lbSaturnSign.Color := SignsColors[planets[i].sign];
        //lbSaturnAngle.Caption := FloatToStr(t1);
        lbSaturnAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbSaturnSubSign.Caption := Signs[k];
        //lbSaturnSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbSaturnSubSign.Font.Color :=  SignsColors[planets[i].subsign];
        lbSaturnSubSign.Color :=  SignsColors[planets[i].subsign];
        edSaturnNumber.Text := FormatStageNumbers(tempDouble);
        //lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edSaturnNumber.Text);
      end;
      7 :
      begin
        lbUranusName.Font.Color := PlantesColors[i];
        lbUranus.Font.Color := PlantesColors[i];
        edUranus.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbUranusSign.Caption := Signs[j];
        //lbUranusSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbUranusSign.Font.Color := SignsColors[planets[i].sign];
        lbUranusSign.Color := SignsColors[planets[i].sign];
        //lbUranusAngle.Caption := FloatToStr(t1);
        lbUranusAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbUranusSubSign.Caption := Signs[k];
        //lbUranusSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbUranusSubSign.Font.Color :=  SignsColors[planets[i].subsign];
        lbUranusSubSign.Color :=  SignsColors[planets[i].subsign];
        edUranusNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edUranusNumber.Text);
      end;
      8 :
      begin
        lbNeptuneName.Font.Color := PlantesColors[i];
        lbNeptune.Font.Color := PlantesColors[i];
        edNeptune.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbNeptuneSign.Caption := Signs[j];
        //lbNeptuneSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbNeptuneSign.Font.Color := SignsColors[planets[i].sign];
        lbNeptuneSign.Color := SignsColors[planets[i].sign];
        //lbNeptuneAngle.Caption := FloatToStr(t1);
        lbNeptuneAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbNeptuneSubSign.Caption := Signs[k];
        //lbNeptuneSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbNeptuneSubSign.Font.Color := SignsColors[planets[i].subsign];
        lbNeptuneSubSign.Color := SignsColors[planets[i].subsign];
        edNeptuneNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edNeptuneNumber.Text);
      end;
      9 :
      begin
        lbPlutoName.Font.Color := PlantesColors[i];
        lbPluto.Font.Color := PlantesColors[i];
        edPluto.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbPlutoSign.Caption := Signs[j];
        //lbPlutoSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbPlutoSign.Font.Color := SignsColors[planets[i].sign];
        lbPlutoSign.Color := SignsColors[planets[i].sign];
        //lbPlutoAngle.Caption := FloatToStr(t1);
        lbPlutoAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbPlutoSubSign.Caption := Signs[k];
        //lbPlutoSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbPlutoSubSign.Font.Color := SignsColors[planets[i].subsign];
        lbPlutoSubSign.Color := SignsColors[planets[i].subsign];
        edPlutoNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edPlutoNumber.Text);
      end;
      11 :
      begin
        lbNNName.Font.Color := PlantesColors[i];
        lbNN.Font.Color := PlantesColors[i];
        edNordNode.Text := FormatFloat(lDegreeFormat,tempDouble);
        lbNordNodeSign.Caption := Signs[j];
        //lbNordNodeSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].sign-1)*30/360,0.9,0.5),$44));
        //lbNordNodeSign.Font.Color := SignsColors[planets[i].sign];
        lbNordNodeSign.Color := SignsColors[planets[i].sign];
        //lbNordNodeAngle.Caption := FloatToStr(t1);
        lbNordNodeAngle.Caption := FormatFloat(lDegreeFormat,t1);
        lbNordNodeSubSign.Caption := Signs[k];
        //lbNordNodeSubSign.Font.Color := WinColor(SetAlpha(hsltorgb((planets[i].subsign-1)*30/360,0.9,0.5),$44));
        //lbNordNodeSubSign.Font.Color := SignsColors[planets[i].subsign];
        lbNordNodeSubSign.Color := SignsColors[planets[i].subsign];
        edNNNumber.Text := FormatStageNumbers(tempDouble);
//        lastValues[i] := aTmpNumber;
        lastValues[i] := GetLastStageNumber(edNNNumber.Text);
      end;
      10 :
      begin
        edAries.Text := '0';
        lbAriesSign.Caption := 'x';
        lbAriesAngle.Caption := '0';
        lbAriesSubSign.Caption := 'x';
        lastValues[i] := 0;        
      end;
    end;
  end;
  // calculez total degree number
  aTmpNumber := 0;
  for i := 0 to 11 do begin
    if lastValues[i] <> 10 then
      aTmpNumber := aTmpNumber+lastValues[i];
  end;
  {
  aStages := reduceNr(aTmpNumber,True);
  for l := 1 to 10 do begin
    if aStages[l] <> -1 then begin
      aTmpNumber := aStages[l];
      if l = 1 then
        aText := IntToStr(aStages[l])
      else
        aText := aText +'='+ IntToStr(aStages[l]);
    end;
  end;
  }
  edTotalDegreeNumber.Text := FormatStageNumbers(aTmpNumber);

end;

procedure TfrmMain.btnCalculateTextClick(Sender: TObject);
var aText,aString : string;
    aStages : TStagesReduce;
    i : Integer;
    aList : TStringList;
    aStatistics: TNumberStatistic;
begin
  aText := memText.Text;

  //edTextNumber.Text := IntToStr(reduceText(aText,False,edDictionary.EditValue)[1]);
  aList := getWords(aText);
  aString := '';
  for i := 0 to aList.Count-1 do begin
    aString := aString+' '+digits(aList[i],edDictionary.ItemIndex+1);
  end;
  edInputDigits.Text :=  aString;

  aStatistics := getTextNumbersStatistics(aString);
  WriteToChart(aStatistics);

  aStages := reduceText(aText,True,edDictionary.ItemIndex+1);
  aString := '';
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      if i = 0 then
        aString := IntToStr(aStages[i])
      else
        aString := aString +'='+ IntToStr(aStages[i]);
  end;
  edTextNumerStages.Text := aString;

  edVowels.Text := digits(getVowels(aText),edDictionary.ItemIndex+1);
//  edVowelsNumber.Text := IntToStr(reduceText(getVowels(aText),False,edDictionary.ItemIndex+1)[1]);

  aStages := reduceText(getVowels(aText),True,edDictionary.ItemIndex+1);
  aString := '';
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      if i = 0 then
        aString := IntToStr(aStages[i])
      else
        aString := aString +'='+ IntToStr(aStages[i]);
  end;
  edVowelsNumerStages.Text := aString;

  edConsonants.Text := digits(getConsonants(aText),edDictionary.ItemIndex+1);
  //edConsonantsNumber.Text := IntToStr(reduceText(getConsonants(aText),False,edDictionary.ItemIndex+1)[1]);
  aStages := reduceText(getConsonants(aText),True,edDictionary.ItemIndex+1);
  aString := '';
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      if i = 0 then
        aString := IntToStr(aStages[i])
      else
        aString := aString +'='+ IntToStr(aStages[i]);
  end;
  edConsonantsNumerStages.Text := aString;

  edInitials.Text := digits(getInitials(aText),edDictionary.ItemIndex+1);
  //edInitialsNumber.Text := IntToStr(reduceText(getInitials(aText),False,edDictionary.ItemIndex+1)[1]);
  aStages := reduceText(getInitials(aText),True,edDictionary.ItemIndex+1);
  aString := '';
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      if i = 0 then
        aString := IntToStr(aStages[i])
      else
        aString := aString +'='+ IntToStr(aStages[i]);
  end;
  edInitialsNumerStages.Text := aString;

  edLasts.Text := digits(getLasts(aText),edDictionary.ItemIndex+1);
  //edLastsNumber.Text := IntToStr(reduceText(getLasts(aText),False,edDictionary.ItemIndex+1)[1]);
  aStages := reduceText(getLasts(aText),True,edDictionary.ItemIndex+1);
  aString := '';
  for i := 1 to 10 do begin
    if aStages[i] <> -1 then
      if i = 0 then
        aString := IntToStr(aStages[i])
      else
        aString := aString +'='+ IntToStr(aStages[i]);
  end;
  edLastsNumerStages.Text := aString;

  edEvolution.Text := evolve(aText,edDictionary.ItemIndex+1,True);

  JvPageControl1.ActivePageIndex := 1;
  ClearDateEdits;
end;

procedure TfrmMain.btnCautaClick(Sender: TObject);
begin
  //
  if Trim(edCautaEvent.Text) <> '' then
  begin
    qryEvents.Active := False;
    qryEvents.SQL[1] := ' where Tags like ''%'+edCautaEvent.Text+'%'' or Details like ''%'+edCautaEvent.Text+'%''';
    OpenEventsDataSet;
    if not chkShowDataBase.Checked then
      chkShowDataBase.Checked := True;
    chkEventsFiltered.Enabled := True;
    chkEventsFiltered.OnClick := nil;
    chkEventsFiltered.Checked := True;
    chkEventsFiltered.OnClick := chkEventsFilteredClick;
  end
  else
    ShowMessageUser('Please specify a search criteria!');
end;

procedure TfrmMain.btnDeleteEventClick(Sender: TObject);
begin
  Cmd_DeleteEventExecute(Sender);
end;

procedure TfrmMain.btnRefreshClick(Sender: TObject);
begin
  MonitorChange(Sender);
end;

procedure TfrmMain.btnReplaceInDBClick(Sender: TObject);
var lDate : TDatetime;
    lYear, lMonth, lDay, lHour, lMinute : Integer;
begin
  // actualizez datele aduse / afisate
  if IdEvents >  0 then
  begin
    ReplaceToDB(natalPlanets,checkedPlanets);
    // dupa ce am salvat sa reset forma
    ClearDateEdits;
    if chkShowDataBase.Checked then
      OpenEventsDataSet;
  end;
 end;

procedure TfrmMain.btnSaveToDbClick(Sender: TObject);
var
  lResult : string;
  isSaving : Boolean;
begin
  lResult :=  existsEvent;
  isSaving := True;
  // daca event-ul cu data specificata exista intreb ...
  if lResult <> '' then
    if MessageDlg('Event with  '+#13#10+'" '+lResult+'" '+ #13#10+' already exists! '+
              'Do you want to add?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      isSaving := False;
  // testez daca nu are ceva completat la detalii sau tag-uri
  if (Trim(memoDetails.Text)='') and  (Trim(memoTags.Text)='') then
    if MessageDlg('Details and Tags are empty!'+ #13#10+'Do tou want to save?',
                  mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      isSaving := False;

  if isSaving then
  begin
    WriteToDB(natalPlanets,checkedPlanets);
    // dupa ce am salvat sa reset forma
    ClearDateEdits;
    if chkShowDataBase.Checked then
      OpenEventsDataSet;
  end;
end;

procedure TfrmMain.ClearTextEdits;
begin
  // fac curatenie la edit-urile de la tab-ul text
  edInputDigits.Clear;
  edVowels.Text := '';
  //edVowelsNumber.Text := '';
  edVowelsNumerStages.Text := '';
  edConsonants.Text := '';
  //edConsonantsNumber.Text := '';
  edConsonantsNumerStages.Text := '';
  edInitials.Text := '';
  //edInitialsNumber.Text := '';
  edInitialsNumerStages.Text := '';
  edLasts.Text := '';
  //edLastsNumber.Text := '';
  edLastsNumerStages.Text := '';
  edEvolution.Text := '';
  edTextNumerStages.Text := '';

end;

procedure TfrmMain.ClearDateEdits;
begin
  // fac clear la edit-urile de la tab-ul date
  IdEvents := -1;
  edDateNumber.Text := '';

  lbSunName.Font.Color := clBlack;
  lbSun.Font.Color := clBlack;
  edSun.Text := '0';
  lbSunSign.Font.Color :=clBlack;
  lbSunAngle.Caption := 'x';
  lbSunSubSign.Caption := 'x';
  lbSunSubSign.Font.Color := clBlack;
  edSunNumber.Text := '';

  lbMoonName.Font.Color := clBlack;
  lbMoon.Font.Color := clBlack;
  edMoon.Text := '0';
  lbMoonSign.Font.Color := clBlack;
  lbMoonAngle.Caption := 'x';
  lbMoonSubSign.Caption := 'x';
  lbMoonSubSign.Font.Color := clBlack;
  edMoonNumber.Text := '';

  lbMercuryName.Font.Color := clBlack;
  lbMercury.Font.Color := clBlack;
  edMercury.Text := '0';
  lbMercurySign.Font.Color := clBlack;
  lbMercuryAngle.Caption := 'x';
  lbMercurySubSign.Caption := 'x';
  lbMercurySubSign.Font.Color := clBlack;
  edMercuryNumber.Text := '';

  lbVenusName.Font.Color := clBlack;
  lbVenus.Font.Color := clBlack;
  edVenus.Text := '0';
  lbVenusSign.Font.Color := clBlack;
  lbVenusAngle.Caption := 'x';
  lbVenusSubSign.Caption := 'x';
  lbVenusSubSign.Font.Color := clBlack;
  edVenusNumber.Text := '';

  lbMarsName.Font.Color := clBlack;
  lbMars.Font.Color := clBlack;
  edMars.Text := '0';
  lbMarsSign.Font.Color := clBlack;
  lbMarsAngle.Caption := 'x';
  lbMarsSubSign.Caption := 'x';
  lbMarsSubSign.Font.Color :=clBlack;
  edMarsNumber.Text := '';

  lbJupiterName.Font.Color := clBlack;
  lbJupiter.Font.Color := clBlack;
  edJupiter.Text := '0';
  lbJupiterSign.Font.Color := clBlack;
  lbJupiterAngle.Caption := 'x';
  lbJupiterSubSign.Caption := 'x';
  lbJupiterSubSign.Font.Color := clBlack;
  edJupiterNumber.Text := '';

  lbSaturnName.Font.Color := clBlack;
  lbSaturn.Font.Color := clBlack;
  edSaturn.Text := '0';
  lbSaturnSign.Font.Color := clBlack;
  lbSaturnAngle.Caption := 'x';
  lbSaturnSubSign.Caption := 'x';
  lbSaturnSubSign.Font.Color :=clBlack;
  edSaturnNumber.Text := '';

  lbUranusName.Font.Color := clBlack;
  lbUranus.Font.Color := clBlack;
  edUranus.Text := '0';
  lbUranusSign.Font.Color := clBlack;
  lbUranusAngle.Caption := 'x';
  lbUranusSubSign.Caption := 'x';
  lbUranusSubSign.Font.Color := clBlack;
  edUranusNumber.Text := '';

  lbNeptuneName.Font.Color := clBlack;
  lbNeptune.Font.Color := clBlack;
  edNeptune.Text := '0';
  lbNeptuneSign.Font.Color := clBlack;
  lbNeptuneAngle.Caption := 'x';
  lbNeptuneSubSign.Caption := 'x';
  lbNeptuneSubSign.Font.Color := clBlack;
  edNeptuneNumber.Text := '';

  lbPlutoName.Font.Color := clBlack;
  lbPluto.Font.Color := clBlack;
  edPluto.Text := '0';
  lbPlutoSign.Font.Color := clBlack;
  lbPlutoAngle.Caption := 'x';
  lbPlutoSubSign.Caption := 'x';
  lbPlutoSubSign.Font.Color := clBlack;
  edPlutoNumber.Text := '';


  lbNNName.Font.Color := clBlack;
  lbNN.Font.Color := clBlack;
  edNordNode.Text := '0';
  lbNordNodeSign.Font.Color := clBlack;
  lbNordNodeAngle.Caption := 'x';
  lbNordNodeSubSign.Caption := 'x';
  lbNordNodeSubSign.Font.Color :=clBlack;
  edNNNumber.Text := '';

  edAries.Text := '0';
  lbAriesSign.Caption := 'x';
  lbAriesAngle.Caption := '0';
  lbAriesSubSign.Caption := 'x';

  edTotalDegreeNumber.Text := '';

  memoDetails.Text := '';
  memoTags.Text := '';

end;

procedure TfrmMain.WriteToTmpDataSet(aDate : TDateTime; aParentId : Integer=1);
begin
  // scriu valorile aduse din clipbiard - cele de tip data
  with memTemporar do begin
    Insert;
    IsInserting := True;
    FieldByName('Data').AsDateTime := aDate;
    if aParentId < 0 then
      FieldByName('Comentarii').AsString := 'Session'
    else
      FieldByName('Comentarii').AsString := '';
    if aParentId < 0 then
      FieldByName('Afisare').AsString := FieldByName('Comentarii').AsString+'-'+DateToStr(FieldByName('Data').AsDateTime)
    else
      FieldByName('Afisare').AsString := DateTimeToStr(FieldByName('Data').AsDateTime);
    if aParentId >=0 then
      FieldByName('IdParinte').AsInteger := aParentId;
    Post;
    IsInserting := False;    
  end;
end;

procedure TfrmMain.memTemporar1ComentariiValidate(Sender: TField);
begin
  // actualizez campul Afisare
  if not IsInserting then
    with memTemporar do begin
      if not (State in dsEditModes) then
        Edit;
      FieldByName('Afisare').AsString := DateTimeToStr(FieldByName('Data').AsDateTime)+'-'+FieldByName('Comentarii').AsString;
    end;
end;

procedure TfrmMain.Cmd_HistDeleteExecute(Sender: TObject);
begin
  // sterg inregistrarea curenta din history
  memTemporar.Delete;
  
end;

procedure TfrmMain.Cmd_HistSaveNodeExecute(Sender: TObject);
begin
  // salvez inregistrarea curenta in sqlite
end;

procedure TfrmMain.Cmd_HistSaveAllExecute(Sender: TObject);
begin
  // salvez toate inregistrarile temporare to sqlite
  
end;

procedure TfrmMain.Cmd_HistDeleteAllExecute(Sender: TObject);
begin
  // sterg toate inregistrarile din temporar - mem
  memTemporar.Active := False;
  memTemporar.Active := True;
  WriteToTmpDataSet(Now,-1);
end;

procedure TfrmMain.Cmd_HistLoadExecute(Sender: TObject);
begin
 // aduc data in prezent -
  memText.Clear;
  memText.Lines.Add(memTemporar.FieldByName('Data').AsString);
  edDate.Date := memTemporar.FieldByName('Data').AsDateTime;
  chkVerified.Checked := True;
  btnCalculateClick(Sender);
  JvPageControl1.ActivePageIndex := 0;
  ClearTextEdits;
end;

procedure TfrmMain.treeHistoryDblClick(Sender: TObject);
begin
  Cmd_HistLoadExecute(Sender);
end;

function TfrmMain.VerifyExistTagInMemo(aTag : string) : Boolean;
begin
  // verific daca exista tag-ul in memo
  Result := False;
  if Pos(aTag,memoTags.Text) > 0 then
    Result := True;
end;

initialization
 swe_set_ephe_path('.');

finalization
 swe_close;


end.
