unit FunctiiAstro;

interface

uses Math, Graphics;
//type TPlanetsEnum = (Su=0,Mo,Me,Ve,Ma,Ju,Sa,Ur,Ne,Pl,NN=11,Ea=14);
type TPlanetInfo = record
  s,s2: string;
  col: TColor;
  ch: Char;
  cycle: Double;
end;

type TSignInfo = record
  s,s3: string;
  col,colElem: TColor;
  ch: Char;
  deg: Double;
end;


const
  su=0;mo=1;me=2;ve=3;ma=4;ju=5;sa=6;ur=7;ne=8;pl=9;nn=11;ea=14;
  ari=1;tau=2;gem=3;cra=4;leo=5;vir=6;lib=7;sco=8;sag=9;cap=10;aqu=11;pis=12;
var
  tempInt: Integer;
  tempDouble: Double;
  tempBool: Boolean;
  pInfo : array[0..14] of TPlanetInfo =
    (
      (s:'Sun'; s2:'Su'; {col: clGoldenRod;} ch:#33; cycle:365.25 ),
      (s:'Moon'; s2:'Mo'; {col: clWebBlack;} ch:#34; cycle:27.32158 ),
      (s:'Mercury'; s2:'Me'; {col: clWebDeepskyBlue;} ch:#35; cycle:87.9691 ),
      (s:'Venus'; s2:'Ve'; {col: clWebLimeGreen;} ch:#36; cycle:224.70069 ),
      (s:'Mars'; s2:'Ma'; {col: clWebRed; ch:#37;} cycle:686.98 ),
      (s:'Jupiter'; s2:'Ju'; {col: clWebDarkOrange;} ch:#38; cycle:4331.572 ),
      (s:'Saturn'; s2:'Sa'; {col: clWebMaroon;} ch:#39; cycle:10760 ),
      (s:'Uranus'; s2:'Ur'; {col: clWebDodgerBlue;} ch:#40; cycle:30799.095 ),
      (s:'Neptune'; s2:'Ne'; {col: clWebDarkOrchid;} ch:#41; cycle:60190 ),
      (s:'Pluto'; s2:'Pl';{col: clWebPurple;} ch:#78; cycle:90613.305 ),
      (),
      (s:'NorthNode'; s2:'NN'; {col: clWebBlack;} ch:#43; cycle:6578.15 ),
      (),
      (),
      (s:'Earth'; s2:'Ea'; {col: clWebDarkgreen;} ch:#124; cycle:365.25 )

    ) ;
  sInfo : array[1..13] of TSignInfo =
    (
      (s:'Aries'; s3:'Ari'; {col: clWebRed; colElem: clWebCrimson;} ch:#80; deg:0.0 ),
      (s:'Taurus'; s3:'Tau'; {col: clWebBurlywood; colElem: clWebBurlywood;} ch:#81; deg:30.0 ),
      (s:'Gemini'; s3:'Gem'; {col: clWebChartreuse; colElem: clWebAquamarine;} ch:#82; deg:60.0 ),
      (s:'Crab'; s3:'Cra'; {col: clWebOliveDrab; colElem: clWebPlum;} ch:#83; deg:90.0 ),
      (s:'Leo'; s3:'Leo'; {col: clWebGold; colElem: clWebTomato;} ch:#84; deg:120.0 ),
      (s:'Virgo'; s3:'Vir'; {col: clWebOlive; colElem: clWebPeru;} ch:#85; deg:150.0 ),
      (s:'Libra'; s3:'Lib'; {col: clWebAqua; colElem: clWebAqua;} ch:#86; deg:180.0 ),
      (s:'Scorpio'; s3:'Sco'; {col: clWebMidnightBlue; colElem: clWebDarkViolet;} ch:#87; deg:210.0 ),
      (s:'Saggitarius'; s3:'Sag'; {col: clWebOrange; colElem: clWebOrangeRed;} ch:#88; deg:240.0 ),
      (s:'Capricorn'; s3:'Cap'; {col: clWebSaddleBrown; colElem: clWebSienna;} ch:#89; deg:270.0 ),
      (s:'Aquarius'; s3:'Aqu'; {col: clWebRoyalBlue; colElem: clWebDeepskyBlue;} ch:#90; deg:300.0 ),
      (s:'Pisces'; s3:'Pis'; {col: clWebPurple; colElem: clWebPurple;} ch:#91; deg:330.0 ),
      (s:'Aries'; s3:'Ari'; {col: clWebRed; colElem: clWebCrimson;} ch:#80; deg:0.0 )
    ) ;
  planetNames : array[0..14] of string = ('Sun','Moo','Mer','Ven','Mar','Jup','Sat','Ura','Nep','Plu','MN','NN','MA','OA','Ea');
  //color planetColors[15] = {Gold, White, DeepSkyBlue, LimeGreen, Red, Orange, Crimson, DodgerBlue, HotPink, Violet,White,White,White,White,SeaGreen,White};
  //color signColors[12] = {White, Red, SaddleBrown, GreenYellow, MediumVioletRed, Gold, DarkGoldenrod, DeepSkyBlue, Navy, Orange, DarkOliveGreen, RoyalBlue, BlueViolet};
  //string signNames[12] = {"Ascendant", "Aries", "Taurus", "Gemini", "Rac", "Leo", "Virgo", "Libra", "Scorpio", "Sagittarius", "Capricorn", "Aquarius", "Pisces"};
  //int planetCycleMin[10] = {525960, 40320, 126675, 323568, 989238, 6237463, 15598550,44350696, 86673600, 130483159 };
  //double planetCycle[15] = {365.256366,27.32166,87.9691,224.70069,686.98,4331.572,10832.327,30799.095,60190,90613.305};
  //double planetMass[15] = {332946, 0.0123, 0.055, 0.815, 0.107, 317.8, 95.152, 14.536, 17.147, 0.0023, 0, 0, 0, 0, 1}; //earth masses
//funtii esentiale
function synodic(p1: Double; p2: Double): Double;
function to360(lon: Double): Double; //to360(lon) <=> toh(lon,360)
function toh(lon: Double;hDeg: Double): Double; //h = 360 => Harmonic 1 (H1)
function toGann(lon: Double): Double; //aries 0, rac 90, libra 0, capr -90
function mirror(lon: Double; m: Double):Double; //m = axa fata de care se face mirroring: m=0 sau m=180 da acelasi rezultat
function isAspect(lonref:Double; lon:Double; aspect:Double; orb:Double=3; harmonically:Boolean=False): Integer;
function isInOrb(lonref:Double; lon:Double; orb:Double=3): Integer;
function signOfLon(lon:Double): Integer;
function elementOfSign(sign:Double):Integer;
function typeOfSign(sign:Double):Integer;
function elementOfLon(lon:Double): Integer;


{Math functions}
function isSolution(value:Double; target:Double; err:Double): Boolean;

//functii neesentiale
//function RGB(const r,g,b:  BYTE):  TColor;

//------------------------------------------------------------------------------
implementation

function synodic(p1: Double; p2: Double): Double;
begin
   synodic := p1*p2 / Abs(p1-p2);
end;

function to360(lon: Double): Double;
begin
  if lon<0 then lon := lon + 360 + Floor(Abs(lon)/360)*360
  else if lon >= 360 then lon := lon - Floor(lon / 360)*360;

  to360 := lon;
end;

function toh(lon: Double;hDeg: Double): Double; //if hDeg = 360 => Harmonic 1 (H1)
begin
 //formula: x - y*floor(x/y) ... floor(-2.6) = -3
 //if (lon>=0 && lon < h) return (lon);
 //saaaau mai general: if (lon<0) { lon += 360 + MathFloor(MathAbs(lon)/360)*360;
 //if (lon<0) lon += 360;
  if (hDeg <> 0) then toh := lon - hDeg*Floor(lon/hDeg)
  else toh:=lon;
end;

function toGann(lon: Double): Double; //trecerea la -90,+90, cu aries si libra 0
begin
  lon := toh(lon,360); //convertim la 360 intai
  if (lon > 90) then
    if lon <= 270 then lon := 180-lon
    else if lon <= 360 then lon := lon-360;
  toGann := lon;
end;

function mirror(lon: Double; m: Double):Double; //m = axa fata de care se face mirroring: m=0 sau m=180 da acelasi rezultat
begin
   mirror := to360(2*m-lon);
end;

function isAspect(lonref:Double; lon:Double; aspect:Double; orb:Double=3; harmonically:Boolean=False): Integer;
var lon1: Double;
begin
   //translatez astfel incat aspect-orb sa fie aries point
   if (not harmonically) then lon1 := to360(lon-lonref-aspect+orb) //daca aspect=60 si orb=3 => doar 57-63 pot fi solutii
   else lon1:=toh(to360(lon-lonref+orb),aspect); //daca aspect=60 si orb=3 => solutii pot fi 357-3, 57-63, 117-123, 177-183 ...

   if (lon1 <= orb) then isAspect:= 1 //applying
   else if (lon1 <= 2*orb) then isAspect:= 2 //separating
        else isAspect:= 0;                   //not in aspect
end;

{cazul particular al functiei isAspect, cu aspect = 0}
function isInOrb(lonref:Double; lon:Double; orb:Double=3): Integer;
var lon1: Double;
begin
   lon1 := to360(lon-lonref+orb); //translatez astfel incat aspect-orb sa fie aries point

   if (lon1 <= orb) then isInOrb:= 1 //applying
   else if (lon1 <= 2*orb) then isInOrb:= 2 //separating
        else isInOrb:= 0;                   //not in orb
end;

function signOfLon(lon:Double): Integer;
begin   //berbec 15deg = 1.5, pesti 15deg = 12.5
   signOfLon:= (Floor(lon / 30) mod 12) + 1;
end;

function elementOfSign(sign:Double):Integer;
begin
   //aries 15 deg = 1.5 => fire => 1.5, pisces 15deg => water => 4.5
   elementOfSign:= (Floor(sign-1) mod 4) + 1;
end;

function typeOfSign(sign:Double):Integer;
begin
  typeOfSign :=  (Floor(sign-1) mod 3) + 1;
end;

function elementOfLon(lon:Double): Integer;
begin
   elementOfLon:= (signOfLon(lon)-1 mod 4) + 1;
end;


{Math Functions}
function isSolution(value:Double; target:Double; err:Double): Boolean;
begin
   isSolution:= (Abs(target - value) < err);
end;

end.
