unit FunctiiAstro;

interface

uses Math;

type
    DegreeMinSec = array[0..2] of Integer;

var
  tempInt: Integer;
  tempDouble: Double;
  tempBool: Boolean;

  planetNames : array[0..14] of string = ('Sun','Moo','Mer','Ven','Mar','Jup','Sat','Ura','Nep','Plu','MN','NN','MA','OA','Ea');
  //color planetColors[15] = {Gold, White, DeepSkyBlue, LimeGreen, Red, Orange, Crimson, DodgerBlue, HotPink, Violet,White,White,White,White,SeaGreen,White};
  //color signColors[12] = {White, Red, SaddleBrown, GreenYellow, MediumVioletRed, Gold, DarkGoldenrod, DeepSkyBlue, Navy, Orange, DarkOliveGreen, RoyalBlue, BlueViolet};
  //string signNames[12] = {"Ascendant", "Aries", "Taurus", "Gemini", "Rac", "Leo", "Virgo", "Libra", "Scorpio", "Sagittarius", "Capricorn", "Aquarius", "Pisces"};
  //int planetCycleMin[10] = {525960, 40320, 126675, 323568, 989238, 6237463, 15598550,44350696, 86673600, 130483159 };
  //double planetCycle[15] = {365.256366,27.32166,87.9691,224.70069,686.98,4331.572,10832.327,30799.095,60190,90613.305};
  //double planetMass[15] = {332946, 0.0123, 0.055, 0.815, 0.107, 317.8, 95.152, 14.536, 17.147, 0.0023, 0, 0, 0, 0, 1}; //earth masses
//funtii esentiale
  function synodicPeriod(p1: Double; p2: Double): Double;
  function to360(lon: Double): Double; //to360(lon) <=> toh(lon,360)
  function toh(lon: Double;hDeg: Double): Double; //h = 360 => Harmonic 1 (H1)
  function toGann(lon: Double): Double; //aries 0, rac 90, libra 0, capr -90
  function mirror(lon: Double; m: Double):Double; //m = axa fata de care se face mirroring: m=0 sau m=180 da acelasi rezultat
  function decimalDegreeToMinSec(aDegree : Double): DegreeMinSec;

//functii neesentiale
//function RGB(const r,g,b:  BYTE):  TColor;

//------------------------------------------------------------------------------
implementation

function synodicPeriod(p1: Double; p2: Double): Double;
begin
   synodicPeriod := p1*p2 / Abs(p1-p2);
end;
                         
function to360(lon: Double): Double;
begin
  if lon<0 then lon := lon + 360 + Floor(Abs(lon)/360)*360
  else if lon >= 360 then lon := lon - Floor(lon / 360)*360;
  
  to360 := lon;
end;

function toh(lon: Double;hDeg: Double): Double; //if hDeg = 360 => Harmonic 1 (H1)
begin
 //formula: x - y*floor(x/y) ... floor(-2.6) = -3
 //if (lon>=0 && lon < h) return (lon);
 //saaaau mai general: if (lon<0) { lon += 360 + MathFloor(MathAbs(lon)/360)*360;
 //if (lon<0) lon += 360;
  toh := lon - hDeg*Floor(lon/hDeg);
end;

function toGann(lon: Double): Double; //trecerea la -90,+90, cu aries si libra 0
begin
  lon := toh(lon,360); //convertim la 360 intai
  if (lon > 90) then
    if lon <= 270 then lon := 180-lon
    else if lon <= 360 then lon := lon-360;
  toGann := lon;  
end;
 
function mirror(lon: Double; m: Double):Double; //m = axa fata de care se face mirroring: m=0 sau m=180 da acelasi rezultat
begin
   mirror := to360(2*m-lon);
end;

function decimalDegreeToMinSec(aDegree : Double): DegreeMinSec;
var temp : Double;
begin
  result[0] := floor(aDegree);
  temp := aDegree - result[0];
  result[1] := floor(temp * 60);
  temp := temp * 60 - result[1];
  result[2] := floor(roundTo(temp * 60,0));
end;

end.
