unit Sessions;

interface

uses
  Classes, SysUtils; 

  type

  { THSession }

  THSession = class
  private
    { private declarations }
    FSessionDate: TDateTime;
    FSessionGUID: TGUID;
    FSessionText: string;
    procedure setSessionDate(AValue: TDateTime);
    procedure setSessionGUID(AValue: TGUID);
    procedure setSessionText(AValue: string);
  public
    { public declarations }
    property SessionDate : TDateTime read FSessionDate write setSessionDate;
    property SessionText : string read FSessionText write setSessionText;
    property SessionGUID : TGUID read  FSessionGUID write setSessionGUID;
  published
    { published declarations }
  end;

  { THSessionNodes }

  THSessionNodes = class
  private
    { private declarations }
    FHistorySession: THSession;
    FNodeComment: string;
    FNodeDate: TDateTime;
    FNodeDisplay: string;
    FNodeGUID: TGUID;
    FNodeTextt: string;
    procedure setHistorySession(AValue: THSession);
    procedure SetNodeComment(AValue: string);
    procedure setNodeDate(AValue: TDateTime);
    procedure setNodeDisplay(AValue: string);
    procedure setNodeGUID(AValue: TGUID);
    procedure setNodeText(AValue: string);
  public
    { public declarations }
    property HistorySession : THSession read FHistorySession write setHistorySession; // sesiunea de care tine
    property NodeDate : TDateTime read FNodeDate write setNodeDate;  // data daca s-a salvat o data
    property NodeText : string read FNodeTextt write setNodeText; // textul daca a fost salvat un text
    property NodeDisplay : string read FNodeDisplay write setNodeDisplay; // textul care se afiseaza in tree
    property NodeGUID : TGUID read  FNodeGUID write setNodeGUID;
    property NodeComment : string read FNodeComment write SetNodeComment;
  published
    { published declarations }
  end;

implementation

{ THSessionNodes }

procedure THSessionNodes.setHistorySession(AValue: THSession);
begin
  if FHistorySession=AValue then Exit;
  FHistorySession:=AValue;
end;

procedure THSessionNodes.SetNodeComment(AValue: string);
begin
  if FNodeComment=AValue then Exit;
  FNodeComment:=AValue;
end;

procedure THSessionNodes.setNodeDate(AValue: TDateTime);
begin
  if FNodeDate=AValue then Exit;
    FNodeDate:=AValue;
end;

procedure THSessionNodes.setNodeDisplay(AValue: string);
begin
  if FNodeDisplay=AValue then Exit;
  FNodeDisplay:=AValue;
end;

procedure THSessionNodes.setNodeGUID(AValue: TGUID);
begin
  FNodeGUID:=AValue;
end;

procedure THSessionNodes.setNodeText(AValue: string);
begin
  if FNodeTextt=AValue then Exit;
  FNodeTextt:=AValue;
end;

{ THSession }

procedure THSession.setSessionDate(AValue: TDateTime);
begin
  FSessionDate:=AValue;
end;

procedure THSession.setSessionGUID(AValue: TGUID);
begin
  FSessionGUID:=AValue;
end;

procedure THSession.setSessionText(AValue: string);
begin
  if FSessionText=AValue then Exit;
  FSessionText:=AValue;
end;

end.

